DAT
{
#########################################################################################################
#                                                                                                       #
#                                                                                                       #
#           d8888 d8b  .d8888b.  888      d8b             888888b.                     d8b              #
#          d88888 Y8P d88P  Y88b 888      Y8P             888  "88b                    Y8P              #
#         d88P888     888    888 888                      888  .88P                                     #
#        d88P 888 888 888        88888b.  888 88888b.     8888888K.   8888b.  .d8888b  888  .d8888b     #
#       d88P  888 888 888        888 "88b 888 888 "88b    888  "Y88b     "88b 88K      888 d88P"        #
#      d88P   888 888 888    888 888  888 888 888  888    888    888 .d888888 "Y8888b. 888 888          #
#     d8888888888 888 Y88b  d88P 888  888 888 888 d88P    888   d88P 888  888      X88 888 Y88b.        #
#    d88P     888 888  "Y8888P"  888  888 888 88888P"     8888888P"  "Y888888  88888P' 888  "Y8888P     #
#                                             888                                                       #
#                                             888                                                       #
#                                             888                                                       #
#                                                                                                       #
#########################################################################################################
}
OBJ
{
        WARNING : Edit _XINFREQ - It is not the default 5MHz !!!
}

CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 7_372_800                             ' 118MHz Operation ! Works for me on ProtoBoard :-)

  TV_PIN        = 12                                    ' Composite video out

  TX_PIN        = 30                                    ' -1 = Disable, 30 = TX via PropPlug, 9 = AiChip
  RX_PIN        = 31                                    ' -1 = Disable, 31 = RX via PropPlug, 8 = AiChip

  BAUD_RATE     = 38400                                 ' Auto-limits to 19200 max at up to 6MHz
                                                         
  KB_DAT_PIN    = 26
  KB_CLK_PIN    = 27

  I2C_SCL_PIN   = 28
  I2C_SDA_PIN   = 29

  TX_PROP_PIN   = 30
  RX_PROP_PIN   = 31
  
  DEMO_SAVE     = false                                 ' Save files to Eeprom
  
DAT
{

Priority Bugs

        LOAD EEPROM borks after asterixes
        
Major bugs

        Variables not implemented fully
        No stack overflow checking ( stackBot =< varTop ? )
        Unary assignments not implemented
        TV Cog info not being reset when TV command issued
                
Minor bugs

        Command line can overflow
        Limited command line editing
        Keyboard doesn't return control characters
        Better space insertion for list line
        Set default colour on debugging / restore to users at end
        #TOK debugging display is screwed
        Print rnd++,rnd throws an end of line error ( other vars work )
        
Known bugs

        Array DIM not implemented
        Proper Array indexing not supported
        Need / no need for dim not checked
        READ not putting data into variables
        READ seems t keep going past end of file
        Stack Init filling for main cog fails
        TxNumber() width > n pads leading zeroes, also need lead spaces
        numberRadix should be pushable / shiftable to allow nesting debug within print
        
Improvements

        Save/load/verify should use a percentage type bar graph to give a better report of fixed width
        holeMark should be derived from main cog stack used ( ie, delete holeMrk )
        Improve Print number/width handling
        permanently remove/include code with @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        Make all text constants txtXXX

Need thinking about

        SD card access
        How to do single line execution
        How to do single statement stepping
                     
}
PRI Version

  result := String( "AiChip Basic 008" )

PRI IsPropellerMkII

  return ChipVer <> 1
  
DAT
{

    8888888          d8b 888    d8b          888 d8b                   888    d8b                   
      888            Y8P 888    Y8P          888 Y8P                   888    Y8P                   
      888                888                 888                       888                          
      888   88888b.  888 888888 888  8888b.  888 888 .d8888b   8888b.  888888 888  .d88b.  88888b.  
      888   888 "88b 888 888    888     "88b 888 888 88K          "88b 888    888 d88""88b 888 "88b 
      888   888  888 888 888    888 .d888888 888 888 "Y8888b. .d888888 888    888 888  888 888  888 
      888   888  888 888 Y88b.  888 888  888 888 888      X88 888  888 Y88b.  888 Y88..88P 888  888 
    8888888 888  888 888  "Y888 888 "Y888888 888 888  88888P' "Y888888  "Y888 888  "Y88P"  888  888 

}
CON

  MAGIC_NUMBER  = $DEAD_D0D0

OBJ

  tv            : "AiChip_Basic_Tv_001"
' tv            : "AiChip_Basic_TvBest_001"
  kb            : "AiChip_Basic_Keyboard_001"
  
  i2c           : "AiChip_Basic_I2C_001"

VAR

  byte runningFromRom
    
PUB Main

  codeBase := ( ( @result + 1024 ) | 1023 ) + 1
  
  CogNewStack( word[ $000E ] , 0 )
  CogSetInfo( CogId , Version )

  CogNewStack( 0, 0 )
  CogSetInfo( 1 , tv.Version )
  tv.Open(  TV_PIN, 0 )

  KbInit

  FileOpenConsole

  EepromOpen( 0 )  

  if TX_PIN == 30 
    if runningFromRom == 0
      i2c.WriteByte( @runningFromRom, -1 )
      WaitCnt( CLKFREQ * 5 + CNT )
    
  BuildOpcLookupTable
  ParseInit
  
  '==debug :=  DEBUG_SHOWLINE | DEBUG_SHOWVARDEF | DEBUG_SHOWEXPR       ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  FlushCode
  StatHelpMain
  
  if DEMO_SAVE
    if IsAnythingSavedToEeprom
      LoadCodeFromEeprom

  if not IsCodeLoadedSameAsCodeSaved

    PushNum( 10 )
    PushVar( String("myVar" ) )
    PushOpc( @symEQ )
    PushOpc( @opcGOTO )
    PushNum( 30 )
    PushOpc( @symCOLON )
    PushOpc( @opcGOTO )
    PushOpc( @symMPY )
    PushVar( String("myVar" ) )
    PushOpc( @tagEOL )

    PushNum( 20 )
    PushOpc( @opcEND )
    PushOpc( @tagEOL )
    
    PushNum( 30 )
    PushVar( String("myVar" ) )
    PushOpc( @symEQ )
    PushOpc( @tagHEX )
    PushNum( $12345678 )
    PushOpc( @tagEOL )

    PushNum( 40 )
    pushopc( @opcPRINT )
    pushopc( @opcHEX )
    pushopc( @symLPARA )
    PushVar( String("myVar" ) )
    pushopc( @symRPARA )
    PushOpc( @tagEOL )

    PushNum( 50 )
    pushopc( @opcPRINT )
    pushopc( @opcHEX )
    pushopc( @symLPARA )
    PushVar( String("myVar" ) )
    pushopc( @symDOT )
    pushopc( @opcMSW)
    pushopc( @symRPARA )
    pushopc( @symCOMMA )
    pushopc( @opcHEX )
    pushopc( @symLPARA )
    PushVar( String("myVar" ) )
    pushopc( @symDOT )
    pushopc( @opcLSW)
    pushopc( @symRPARA )
    PushOpc( @tagEOL )
    
    PushNum( 60 )
    pushopc( @opcPRINT )
    pushopc( @opcHEX )
    pushopc( @symLPARA )
    PushVar( String("myVar" ) )
    pushopc( @symDOT )
    pushopc( @opcMSW)
    pushopc( @symDOT )
    pushopc( @opcMSB)
    pushopc( @symRPARA )
    pushopc( @symCOMMA )
    pushopc( @opcHEX )
    pushopc( @symLPARA )
    PushVar( String("myVar" ) )
    pushopc( @symDOT )
    pushopc( @opcLSW)
    pushopc( @symDOT )
    pushopc( @opcMSB)
    pushopc( @symRPARA )
    PushOpc( @tagEOL )
    PushOpc( @tagEOF )

    codeTop := pc-1
    ResetCode
    
  Str( String( ">LIST",$0D ) )
  ListCode
  
  if DEMO_SAVE
    if not IsCodeLoadedSameAsCodeSaved
      SaveCodeToEeprom

  randomNumber := ? CNT

  CommandLine
  
DAT
{                                                                                                    

               888b     d888          d8b             888                                
               8888b   d8888          Y8P             888                                
               88888b.d88888                          888                                
               888Y88888P888  8888b.  888 88888b.     888      .d88b.   .d88b.  88888b.  
               888 Y888P 888     "88b 888 888 "88b    888     d88""88b d88""88b 888 "88b 
               888  Y8P  888 .d888888 888 888  888    888     888  888 888  888 888  888 
               888   "   888 888  888 888 888  888    888     Y88..88P Y88..88P 888 d88P 
               888       888 "Y888888 888 888  888    88888888 "Y88P"   "Y88P"  88888P"  
                                                                                888      
                                                                                888      
                                                                                888
                                                                                      
}
VAR

  long pc
  long lastPc
  long statPc
  long nextPc

  long dataPc
  
  long lastLineNumber
  long lastLinePc

PRI Execute( n )

  if n
    pc := n
    lastLineNumber := -1
  else
    ResetCode
    pc := codeBot
    lastLineNumber := 0

  result := \ExecuteLoop

  OnNewLine 

  if lastLineNumber => 0 or result <> @aboFINISHED
    TvColor( 0 )
    if result < 0 or byte[ result ] == "*"
      if result < 0
        -result
      else
        ++result
      if byte[ result ] == "{"
        result += StrSize( result ) + 1
      Str( result )
      Str( String( " expected" ) )
    else
      Str( result )
     
    if lastLineNumber => 0 
      Str( String(" in Line ") )
      Dec( lastLineNumber )
      if result == @aboFINISHED
        Out( $0D)
      else
        Str( String( " ...",$0D ) )
        ListLine( lastLinePc )
    else
      Out( $0D )
    
PRI ExecuteLoop

  nextPc := 0
  dataPc := codeBot

  GetToken
  repeat
    Statement

PRI Statement

  if nextPc
    pc := nextPc~
    GetToken

  lastLinePc := lastPc
   
  if token == @tagNUMBER
    lastLineNumber := value
    if debug & DEBUG_SHOWLINE
      Dbg( String( "LIN") )
      Dec( lastLineNumber )
      Out( " " )
      debug |= DEBUG_GAVELNUM
    GetToken
    
  SkipColon
  SingleStatement
  repeat while token == @symCOLON and nextPc == 0
    SkipColon    
    SingleStatement

  if nextPc
    CheckEol
  else
    CheckHardEol
    if byte[ pc ] == lookupAtTagEOF
      Abort @aboFINISHED
    Want( @tagEOL )
    
PRI SingleStatement

  CheckBreak
    
  statPc := lastPc

  if debug & DEBUG_SHOWLINE
    if debug & DEBUG_GAVELNUM
      debug ^= DEBUG_GAVELNUM
    else
      Dbg( String( "LIN") )
    ListLine( statPc )
    
  case token
    @tagEOL    :
    
    @opcEND    : StatEnd
    @opcIF     : StatIf
    @opcELSE   : StatElse
'   @opcELSEIF
    @opcENDIF  : StatEndIf
    @opcREPEAT : StatRepeat
    @opcUNTIL  : StatUntil
    @opcWHILE  : StatWhile
    @opcWEND   : StatWend
'   @opcSELECT
'   @opcCASE
'   @opcFOR
'   @opcNEXT
'   @opcSUB
'   @opcENDSUB
'   @opcFUNCTION
'   @opcENDFUNC
        
    other :
      if conditional[ condTop ]
        case token

          @opcBREAK   : StatBreak
'         @opcCALL
          @opcCLOSE   : StatClose
          @opcCLS     : StatCls
          @opcCOGS    : StatCogs
          @opcCOLOR   : StatColor
          @opcCOLOUR  : StatColor
          @opcDATA    : StatData
          @opcDEBUG   : StatDebug
'         @opcDEF
          @opcDIM     : StatDim
'         @opcEDIT
'         @opcERROR
'         @opcEXIT
          @opcGOTO    : StatGoto
          @opcGOSUB   : StatGosub
          @opcHELP    : StatHelp
          @opcHIGH    : StatHigh_Low_Toggle( TX_CMD_HIGH )
'         @opcINPUT
'         @opcKILL
          @opcLIST    : StatList
          @opcLOAD    : StatLoad
          @opcLOCATE  : StatLocate
          @opcLOW     : StatHigh_Low_Toggle( TX_CMD_LOW )
'         @opcMODE
          @opcMEM     : StatMem
'         @opcNAME
          @opcNEW     : StatNew
'         @opcON
          @opcOPEN    : StatOpen
'         @opcOUTPUT
          @opcPAUSE   : StatPause
'         @opcPOP
          @opcPRINT   : StatPrint
'         @opcPUSH
'         @opcQUIT
          @opcREAD    : StatRead
'         @opcREBOOT
'         @opcRENUM
'         @opcRESET
          @opcRESTORE : StatRestore
          @opcRETURN  : StatReturn
          @opcRUN     : StatRun
          @opcSAVE    : StatSave
'         @opcSHELL
'         @opcSTART
'         @opcSTEP
'         @opcSTOP
'         @opcSYSTEM
          @opcTOGGLE  : StatHigh_Low_Toggle( TX_CMD_TOGGLE )
          @opcTV      : StatTv
          @opcVARS    : StatVars
          @opcWAITCNT : StatWaitCnt
          @opcWAITPEQ : StatWaitPxx
          @opcWAITPNE : StatWaitPxx

          @opcLET     : GetToken
                        Assignment
                        
          @tagVAR, @tagNEW, @tagREG, @opcSPR, @opcBYTE, @opcWORD, @opcLONG, @opcEEPROM, @opcRND, {
}         @symINC, @symDEC :
                        Assignment
                        
          @symSUB, @symNOT, @symABS, @symSQR, @symRND, @opcLOGNOT :
                        UnaryAssignment

          other : Abort @aboSTATEMENT_EXPECTED
      else
        repeat
          GetToken
        until token == @tagEOL or token == @symCOLON

  CheckEol
     
PRI SkipColon

  if token == @symCOLON
    GetToken
    repeat while token == @symCOLON
      GetToken

PRI CheckEol

  if token <> @tagEOL and token <> @symCOLON
    Abort -@tagEOL

PRI CheckHardEol

  if token <> @tagEOL
    Abort -@tagEOL
              
PRI Want( n )

  if token <> n
    Abort -n
  GetToken

PRI CheckBreak

  if rxBreak~ or kbBreak~
    Abort @opcBREAK
    
DAT
{

        .d8888b.  888             888                                            888             
       d88P  Y88b 888             888                                            888             
       Y88b.      888             888                                            888             
        "Y888b.   888888  8888b.  888888 .d88b.  88888b.d88b.   .d88b.  88888b.  888888 .d8888b  
           "Y88b. 888        "88b 888   d8P  Y8b 888 "888 "88b d8P  Y8b 888 "88b 888    88K      
             "888 888    .d888888 888   88888888 888  888  888 88888888 888  888 888    "Y8888b. 
       Y88b  d88P Y88b.  888  888 Y88b. Y8b.     888  888  888 Y8b.     888  888 Y88b.       X88 
        "Y8888P"   "Y888 "Y888888  "Y888 "Y8888  888  888  888  "Y8888  888  888  "Y888  88888P' 
                                                                                                 
}
DAT
{
         ___  ___   ___   __   _ _  
        (  ,)(  ,) (  _) (  ) ( ) ) 
         ) ,\ )  \  ) _) /__\  )  \ 
        (___/(_)\_)(___)(_)(_)(_)\_)
}

PRI StatBreak

  ' BREAK # file, expr_mS

  GetToken
  StatBreakPart( TX_CMD_BREAK )
  
PRI StatBreakPart( txCmdValue ) | f
  
  Want( @symHash )
  f := FileNumber
  if fileMode[f] & FILE_MODE_OUTPUT
    if token == @symCOMMA
      GetToken
      TxPut( txCmdValue | f, Expr <# 255 )
    else
      TxPut( txCmdValue | f, ( ( CLKFREQ / fileBitTime[f] * 11 ) / 1000 ) #> 1 )
  else
    Abort @aboBAD_FILE_MODE

DAT
{
          __   __   __    __
         / _) (  ) (  )  (  )
        ( (_  /__\  )(__  )(__
         \__)(_)(_)(____)(____)
}
DAT
DAT
{
          __  __    __   ___  ___
         / _)(  )  /  \ / __)(  _)
        ( (_  )(__( () )\__ \ ) _)
         \__)(____)\__/ (___/(___)
}

PRI StatClose

  ' CLOSE
  ' CLOSE # file { , {#} file ... }
  
  GetToken
  if token == @tagEOL
    FileCloseAll
  else
    Want( @symHASH )
    FileClose( FileNumber )
    repeat while token == @symCOMMA
      GetToken
      if token == @symHASH
        GetToken
      FileClose( FileNumber )
        
DAT
{
          __  __    ___
         / _)(  )  / __)
        ( (_  )(__ \__ \
         \__)(____)(___/
}

PRI StatCls | n 

  ' CLS
  
  GetToken
  TvCls
  
DAT
{
          __  __    __  ___ 
         / _)/  \  / _)/ __)
        ( (_( () )( (/\\__ \
         \__)\__/  \__/(___/

}

PRI StatCogs

  ' COGS
  
  GetToken
  CheckEol
  ListCogs
  
DAT
{
          __  __  __    __  ___       _       __  __  __    __  _  _  ___  
         / _)/  \(  )  /  \(  ,)    _( )_    / _)/  \(  )  /  \( )( )(  ,)
        ( (_( () ))(__( () ))  \   (_   _)  ( (_( () ))(__( () ))()(  )  \ 
         \__)\__/(____)\__/(_)\_)    (_)     \__)\__/(____)\__/ \__/ (_)\_)

}

PRI StatColor | n

  ' COLOR color
  ' COLOR color AS palettesetting
  
  GetToken
  n := Expr & $F
  TvColor( n )
    
DAT
{
         ___   __  ____  __
        (   \ (  )(_  _)(  )
         ) ) )/__\  )(  /__\
        (___/(_)(_)(__)(_)(_)
}

PRI StatData

  ' DATA expr { , expr ... }
  
  StatDataPart
  repeat while token == @symCOMMA
    StatDataPart

PRI StatDataPart

  GetToken
  Expr
  
DAT
{
         ___  ___  ___  _  _  __ 
        (   \(  _)(  ,)( )( )/ _)
         ) ) )) _) ) ,\ )()(( (/\
        (___/(___)(___/ \__/ \__/
}
PRI StatDebug | n

  ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  '
  ' This is currently rigged to dump all subsequent tokens in byte form up to EOL
  '
  ' eg 10 DEBUG : PRINT "ABC"
  
  GetToken
  n := lastPc
  repeat while opcLookupTable[ byte[ n ] ] <> @tagEOL
    Hex( byte[ n++ ], 2 )
    Out( $0D )
       
DAT
{
         ___  ___  ___
        (   \(  _)(  _)
         ) ) )) _) ) _)
        (___/(___)(_)
}
DAT
DAT
{
         ___  __  __  __
        (   \(  )(  \/  )
         ) ) ))(  )    (
        (___/(__)(_/\/\_)
}

PRI StatDim

  ' DIM var ( expr )
  ' DIM var [ expr ]
  
  StatDimPart
  repeat while token == @symCOMMA
    StatDimPart

PRI StatDimPart | byteSize, varSize, nLastPc
  GetToken
  if token == @tagVAR
    Abort @aboALREADY_DEFINED
  if token <> @tagNEW
    Abort -@tagVAR
  nLastPc := lastPc
  varSize := GetVarSizeFromType( varType )
  GetToken
  if token == @symLPARA
    GetToken
    byteSize := StatDimSize(1)
    Want( @symRPARA )
  else
    Want( @symLBRACKET )
    byteSize := StatDimSize(0)
    Want( @symRBRACKET )
  byteSize *= varSize
  AddNewVar( byteSize, nlastPc + 3 + ( IsPropellerMkII & 1 ) )
                           
PRI StatDimSize( n ) : byteSize | thisSize

  if ( byteSize := ( Expr + n ) ) =< 0
    Abort @aboBAD_DIM_SIZE
  repeat while token == @symCOMMA
    GetToken
    if ( thisSize := ( Expr + n ) ) =< 0
      Abort @aboBAD_DIM_SIZE
    byteSize *= thisSize 

DAT
{
         ___  ___  __  ____ 
        (  _)(   \(  )(_  _)
         ) _) ) ) ))(   )(  
        (___)(___/(__) (__) 
}
DAT
DAT
{
         ___  _  _  ___
        (  _)( \( )(   \
         ) _) )  (  ) ) )
        (___)(_)\_)(___/
}

PRI StatEnd

  ' END
  ' END IF
  ' END WHILE
  
  GetToken
  case token
    @tagEOL   : if conditional[ condTop ]
                  Abort @aboFINISHED
    @opcIF    : StatEndIf
    @opcWHILE : StatWend
    
DAT
{
         ___  ___   ___   __  ___
        (  _)(  ,) (  ,) /  \(  ,)
         ) _) )  \  )  \( () ))  \
        (___)(_)\_)(_)\_)\__/(_)\_)
}
DAT
DAT
{
         ___  _  _  __  ____
        (  _)( \/ )(  )(_  _)
         ) _) )  (  )(   )(
        (___)(_/\_)(__) (__)
}
DAT
DAT
{
         ___   __  ___            _  _  ___  _  _  ____ 
        (  _) /  \(  ,)    ___   ( \( )(  _)( \/ )(_  _)
         ) _)( () ))  \   (___)   )  (  ) _) )  (   )(  
        (_)   \__/(_)\_)         (_)\_)(___)(_/\_) (__) 
}
DAT
DAT
{
         ___  _  _  _  _  __  ____  __  __  _  _
        (  _)( )( )( \( )/ _)(_  _)(  )/  \( \( )
         ) _) )()(  )  (( (_   )(   )(( () ))  (
        (_)   \__/ (_)\_)\__) (__) (__)\__/(_)\_)
}
DAT
DAT
{
          __   __   ___  _  _  ___
         / _) /  \ / __)( )( )(  ,)
        ( (/\( () )\__ \ )()(  ) ,\
         \__/ \__/ (___/ \__/ (___/
}

PRI StatGosub

  ' GOSUB linenumber
  ' GOSUB * variable

  nextPc := PreCachedLineNumber
  PushWord( lastPc )
  CondPush( true, @opcRETURN )
  
DAT
{
          __   __  ____  __
         / _) /  \(_  _)/  \
        ( (/\( () ) )( ( () )
         \__/ \__/ (__) \__/

}
PRI StatGoto

  ' GOTO linenumber
  ' GOTO * variable

  nextPc := PreCachedLineNumber
  
DAT
{
         _  _  ___  __    ___ 
        ( )( )(  _)(  )  (  ,\
         )__(  ) _) )(__  ) _/
        (_)(_)(___)(____)(_)  
         
}
PRI StatHelp

  ' HELP
  
  GetToken
  CheckEol
  StatHelpMain
  Str( String( "http://forums.parallax.com/forums/default.aspx?f=25&m=264289",$0D ))
  StatHelpListCommands

PRI StatHelpMain

  Str( Version )
  Str( String( " - " ) )
  Dkb( $8000 - codeBase )
  Out( " " )
  Mhz( CLKFREQ )
  Str( String( "MHz" ) )
  if tv.GetMode
    Out( " " )
    if tv.GetMode & tv#TV_MODE_PAL
      Str( @opcPAL )
    else
      Str( @opcNTSC )
    Out( " " )
    Dec( tv.GetRowCount )
    Out( "x" )
    Dec( tv.GetColumnCount )
  Out( $0D )
  Out( $0D )
  
PRI StatHelpListCommands | nPc

  nPc := @opc_LIST_START
  repeat
    if ( result //= 4 )
      Out( 9 )
    else
      Out( $0D )
    Str( nPc )
    nPc += StrSize(nPc)+1
    result++
  while byte[ nPc ]
  if result
    OnNewLine
  Out( $0D )    
    
DAT
{
         _  _  __  __  _  _ 
        ( )( )(  )/ _)( )( )
         )__(  )(( (/\ )__( 
        (_)(_)(__)\__/(_)(_)
}

PRI StatHigh_Low_Toggle( txCmdValue )

  ' HIGH # file { , {#} file ... }
  
  GetToken
  Want( @symHASH )
  StatHigh_Low_Toggle_Part( txCmdValue )
  repeat while token == @symCOMMA
    GetToken
    if token == @symHASH
      GetToken
    StatHigh_Low_Toggle_Part( txCmdValue )

PRI StatHigh_Low_Toggle_Part( txCmdValue ) | f

  f := FileNumber
  if fileMode[f] & FILE_MODE_OUTPUT
    TxPut( txCmdValue | f, 0 )
  else
    Abort @aboBAD_FILE_MODE
   
DAT
{
         __  ___           ___  __    ___  ___           ___  _  _  ___     __  ___ 
        (  )(  _)   ___   (  _)(  )  / __)(  _)   ___   (  _)( \( )(   \   (  )(  _)
         )(  ) _)  (___)   ) _) )(__ \__ \ ) _)  (___)   ) _) )  (  ) ) )   )(  ) _)
        (__)(_)           (___)(____)(___/(___)         (___)(_)\_)(___/   (__)(_) 
}

PRI StatIf

  ' IF expr {THEN}
  ' ENDIF

  ' IF expr {THEN}
  ' ELSE
  ' ENDIF

  ' IF expr THEN stat { ELSE stat }
    
  GetToken
  CondPush( Expr, @opcELSE )
  if token == @opcTHEN
    GetToken
    if token <> @tagEOL
      SingleStatement
      CondPop( @opcELSE )
      if token == @opcELSE
        CondPush( not conditional[ condTop+1 ], @opcENDIF )
        GetToken
        SingleStatement
        CondPop( @opcENDIF )
        
PRI StatElse

  ' IF expr {THEN}
  ' ELSE
  ' ENDIF

  CondPop( @opcELSE )
  CondPush( not conditional[ condTop+1 ], @opcENDIF )
  GetToken
      
PRI StatEndIf

  ' IF expr {THEN}
  ' ENDIF

  ' IF expr {THEN}
  ' ELSE
  ' ENDIF

  if condWant[ condTop ] == @opcELSE
    CondPop( @opcELSE )
  else
    CondPop( @opcENDIF )
  GetToken
        
DAT
{
         __  _  _  ___  _  _  ____
        (  )( \( )(  ,\( )( )(_  _)
         )(  )  (  ) _/ )()(   )(
        (__)(_)\_)(_)   \__/  (__)
}
DAT
DAT
{
         _ _   __  __    __
        ( ) ) (  )(  )  (  )
         )  \  )(  )(__  )(__
        (_)\_)(__)(____)(____)
}
DAT
DAT
{
         __    __  ___  ____
        (  )  (  )/ __)(_  _)
         )(__  )( \__ \  )(
        (____)(__)(___/ (__)
}

PRI StatList

  ' LIST
  ' LIST linenumber
  ' LIST linenumber, count
  ' LIST NEXT
  
  ' LIST COGS
  ' LIST EEPROM
  ' LIST MEM
  ' LIST VARS
  ' LIST OPEN
  ' LIST INPUT
  ' LIST OUTPUT
  
  GetToken  
  if token == @tagEOL
    ListCode
  else
    case token
      @opcNEXT   : ListLines( listFrom, listCount )
      @opcCOGS   : ListCogs
      @opcEEPROM : ListEeprom
      @opcMEM    : ListMemory( true )
      @opcINPUT  : ListFiles( FILE_MODE_INPUT )
      @opcOPEN   : ListFiles( FILE_MODE_OPEN )
      @opcOUTPUT : ListFiles( FILE_MODE_OUTPUT )
      @opcVARS   : ListVars
      other :
        listFrom  := LineNumber
        listCount := 1
        if token == @symCOMMA
          GetToken
          listCount := PositiveNumber
        CheckEol
        ListLines( listFrom, listCount )
        result := true
    if not result
      GetToken

DAT
{
         __    __   __   ___
        (  )  /  \ (  ) (   \
         )(__( () )/__\  ) ) )
        (____)\__/(_)(_)(___/
}

PRI StatLoad

  ' LOAD EEPROM
  
  GetToken
  Want( @opcEEPROM )
  LoadCodeFromEeprom

DAT
{
         __    __    __   __  ____  ___ 
        (  )  /  \  / _) (  )(_  _)(  _)
         )(__( () )( (_  /__\  )(   ) _)
        (____)\__/  \__)(_)(_)(__) (___)
}

PRI StatLocate | n

  ' LOCATE row { , column }
  
  GetToken
  n := PositiveNonZeroNumber
  if token == @symCOMMA
    GetToken
    TvAt( n , PositiveNonZeroNumber )
  else
    TvAtRow( n )

DAT
{
         __    __  _    _ 
        (  )  /  \( \/\/ )
         )(__( () )\    / 
        (____)\__/  \/\/  
}
DAT '   See High Statement
DAT
{
         __  __  ___  __  __
        (  \/  )(  _)(  \/  )
         )    (  ) _) )    (
        (_/\/\_)(___)(_/\/\_)
}


PRI StatMem

  ' MEM
  
  GetToken
  CheckEol
  ListMemory( false )

DAT
{
         __  __  __  ___  ___ 
        (  \/  )/  \(   \(  _)
         )    (( () )) ) )) _)
        (_/\/\_)\__/(___/(___)
}
DAT
DAT
{
         _  _   __   __  __  ___
        ( \( ) (  ) (  \/  )(  _)
         )  (  /__\  )    (  ) _)
        (_)\_)(_)(_)(_/\/\_)(___)
}
DAT
DAT
{
         _  _  ___  _    _
        ( \( )(  _)( \/\/ )
         )  (  ) _) \    /
        (_)\_)(___)  \/\/
}

PRI StatNew

  ' NEW
  
  GetToken
  Want( @tagEOL )
  FlushCode
  abort @aboFINISHED
         
DAT
{
          __  _  _
         /  \( \( )
        ( () ))  (
         \__/(_)\_)
}
DAT
DAT
{
          __  ___  ___  _  _
         /  \(  ,\(  _)( \( )
        ( () )) _/ ) _) )  (
         \__/(_)  (___)(_)\_)
}

PRI StatOpen

  ' OPEN pin,baud,parity,databits,stopbits FOR INPUT|OUTPUT AS # file
  
  GetToken
  
  '   OPEN  pin          , baud         , parity       , data         , stop  FOR mode AS #  file      
  FileOpen( StatOpenExpr1, StatOpenExpr1, StatOpenExpr1, StatOpenExpr1, Expr, StatOpenExpr2, FileNumber )

PRI StatOpenExpr1

  result := Expr
  Want( @symCOMMA )

PRI StatOpenExpr2

  Want( @opcFOR )
  case token
    @opcINPUT  : result := FILE_MODE_INPUT
    @opcOUTPUT : result := FILE_MODE_OUTPUT
    other      : Abort @aboSYNTAX_ERROR
  Want( @opcAS )
  Want( @symHASH )
     
DAT
{
          __  _  _  ____  ___  _  _  ____
         /  \( )( )(_  _)(  ,\( )( )(_  _)
        ( () ))()(   )(   ) _/ )()(   )(
         \__/ \__/  (__) (_)   \__/  (__)
}
DAT
DAT
{
         ___  __  _  _  ___  ___
        (  ,\(  )( )( )/ __)(  _)
         ) _//__\ )()( \__ \ ) _)
        (_) (_)(_)\__/ (___/(___)
}

PRI StatPause | nMs, nUs

  ' PAUSE expr_mS { , expr_uS }

  ' PAUSE # file, expr_mS
  
  GetToken
  if token == @symHASH
    StatBreakPart( TX_CMD_PAUSE )
  else
    nMs := PositiveNumber
    if token == @symCOMMA
      GetToken
      if ( nUs := PositiveNumber )
        if nMs
          nMs -= 1
          nUs += 1000
        else
          nUs #>= 500
        WaitCnt( CLKFREQ / 1_000_000 * nUs + CNT )
    repeat nMs
      CheckBreak
      WaitCnt( CLKFREQ / 1_000 + CNT )
    
DAT
{
         ___  ___   __  _  _  ____
        (  ,\(  ,) (  )( \( )(_  _)
         ) _/ )  \  )(  )  (   )(
        (_)  (_)\_)(__)(_)\_) (__)
}

PRI StatPrint : givenCrLf

  fileHandle := 0
  GetToken
  if token <> @tagEOL
    if token == @symHASH
      GetToken
      fileHandle := PositiveNumber
      Want( @symCOMMA )
      givenCrlF := StatPrintPart
    else
      givenCrLf := StatPrintPart
  if not givenCrLf
    Out( $0D )
  fileHandle := 0
    
PRI StatPrintPart : givenCrLf

  StatPrintPartOne
  repeat while ( token == @symCOMMA ) or ( token == @symSEMICOLON )
    givenCrLf := false
    if token == @symCOMMA
      Out( $09 )
      GetToken
      if token <> @symCOMMA
        StatPrintPartOne
    else
      GetToken
      if not ( givenCrlf := ( token == @tagEOL ) )
        StatPrintPartOne
          
PRI StatPrintPartOne | n, s

  case token
    @opcHEX, @opcBIN, @opcDEC :
      case token
        @opcBIN : numberRadix := 2
        @opcHEX : numberRadix := 16
        other   : numberRadix := 10
      GetToken
      Want( @symLPARA )
      n := Expr
      if token == @symCOMMA
        GetToken
        s := Expr
      else
        s := 0
      Want( @symRPARA )
      OutNumberFormat( n, numberRadix, s )
    @tagTXT :
      printString( lastPc+1 )
      GetToken
    @opcSTR :
      GetToken
      Want( @symLPARA )
      PrintString( Expr )
      Want( @symRPARA )
    @opcCHR :
      GetToken
      Want( @symLPARA )
      Out( PositiveNumber )
      Want( @symRPARA )
    @opcTAB :
      GetToken
      Want( @symLPARA )
      Tab( PositiveNonZeroNumber )
      Want( @symRPARA )
    other :
      Dec( Expr )

PRI PrintString( n )

 repeat
   if ( result := byte[ n++ ] ) & $7F
     ListTextChar( result & $7F )
 while result & $80
   

DAT
{
         ___  _  _  ___  _  _           ___   __  ___ 
        (  ,\( )( )/ __)( )( )   ___   (  ,\ /  \(  ,\
         ) _/ )()( \__ \ )__(   (___)   ) _/( () )) _/
        (_)   \__/ (___/(_)(_)         (_)   \__/(_)  

}
DAT
DAT
{
          __  _  _  __  ____
         /  \( )( )(  )(_  _)
        ( () ))()(  )(   )(
         \___\\__/ (__) (__)
}
DAT
DAT
{
         ___   ___   __   ___
        (  ,) (  _) (  ) (   \
         )  \  ) _) /__\  ) ) )
        (_)\_)(___)(_)(_)(___/
}

PRI StatRead

  StatReadPart
  repeat while token == @symCOMMA
    StatReadPart

PRI StatReadPart

  GetTokenPushState

  pc := || dataPc
  GetToken
  if dataPc > 0
    repeat while token <> @opcDATA
      GetToken
    GetToken
  result := Expr
  if token == @symCOMMA
    dataPc := -Pc
  else
     CheckEol
     dataPc := pc

  GetTokenPopState

  GetToken

DAT
{
         ___   ___  ___   __    __  ____ 
        (  ,) (  _)(  ,) /  \  /  \(_  _)
         )  \  ) _) ) ,\( () )( () ) )(  
        (_)\_)(___)(___/ \__/  \__/ (__)
}
DAT  
DAT
{
         ___   ___  _  _  _  _  __  __
        (  ,) (  _)( \( )( )( )(  \/  )
         )  \  ) _) )  (  )()(  )    (
        (_)\_)(___)(_)\_) \__/ (_/\/\_)
}
DAT
DAT
{
         ___   ___  ___  ___   __  ____           _  _  _  _  ____  __  __   
        (  ,) (  _)(  ,\(  _) (  )(_  _)   ___   ( )( )( \( )(_  _)(  )(  )  
         )  \  ) _) ) _/ ) _) /__\  )(    (___)   )()(  )  (   )(   )(  )(__ 
        (_)\_)(___)(_)  (___)(_)(_)(__)           \__/ (_)\_) (__) (__)(____)
}
PRI StatRepeat

  ' REPEAT
  ' UNTIL expr

  ' REPEAT
  ' WHILE expr

  GetToken
  CondPush( true, @opcUNTIL )

PRI StatUntil

  ' REPEAT
  ' UNTIL expr

  GetToken
  CondPop( @opcUNTIL )
  If not Expr
    if conditional[ condTop+1 ]
      nextPc := condAtPc[ condTop+1 ]

DAT
{
         ___   ___  ___  ___  ____ 
        (  ,) (  _)/ __)(  _)(_  _)
         )  \  ) _)\__ \ ) _)  )(  
        (_)\_)(___)(___/(___) (__) 
}
DAT
DAT
{
         ___   ___  ___  ____  __  ___   ___
        (  ,) (  _)/ __)(_  _)/  \(  ,) (  _)
         )  \  ) _)\__ \  )( ( () ))  \  ) _)
        (_)\_)(___)(___/ (__) \__/(_)\_)(___)
}

PRI StatRestore

  ' RESTORE
  ' RESTORE linenumber
  ' RESTORE * variable
  
  GetToken
  if token <> @tagEOL
    dataPc := LineNumber
  else
    dataPc := codeBot

DAT
{
         ___   ___  ____  _  _  ___   _  _
        (  ,) (  _)(_  _)( )( )(  ,) ( \( )
         )  \  ) _)  )(   )()(  )  \  )  (
        (_)\_)(___) (__)  \__/ (_)\_)(_)\_)
}

PRI StatReturn

  ' RETURN
  
  GetToken
  CheckhardEol

  if condTop =< 0
    Abort @aboNESTING_ERROR
  
  repeat while condWant[ condTop ] == @opcRETURN
    if --condTop =< 0
      Abort @aboNESTING_ERROR
  
  nextPc := PopWord
  
DAT
{
         ___  _  _  _  _
        (  ,)( )( )( \( )
         )  \ )()(  )  (
        (_)\_)\__/ (_)\_)
}

PRI StatRun

  ' RUN
  ' RUN linenumber
  ' RUN * variable

  GetToken
  if token <> @tagEOL
    nextPc := LineNumber
  else
    if ( nextPc := codeBot ) > codeTop
      Abort @aboNO_CODE
  CheckHardEol
  ResetCode
  
DAT
{
         ___   __  _  _  ___
        / __) (  )( )( )(  _)
        \__ \ /__\ \\//  ) _)
        (___/(_)(_)(__) (___)
}

PRI StatSave

  ' SVAE EEPROM
  
  GetToken
  Want( @opcEEPROM )
  SaveCodeToEeprom
  
DAT
{
         ___  ___  ___  _ _
        / __)(  _)(  _)( ) )
        \__ \ ) _) ) _) )  \
        (___/(___)(___)(_)\_)
}
DAT
DAT
{
         ___  ___  __    ___   __  ____            __   __   ___  ___ 
        / __)(  _)(  )  (  _) / _)(_  _)   ___    / _) (  ) / __)(  _)
        \__ \ ) _) )(__  ) _)( (_   )(    (___)  ( (_  /__\ \__ \ ) _)
        (___/(___)(____)(___) \__) (__)           \__)(_)(_)(___/(___)
}
DAT
DAT
{
         ___  _  _  ___  __    __
        / __)( )( )(  _)(  )  (  )
        \__ \ )__(  ) _) )(__  )(__
        (___/(_)(_)(___)(____)(____)
}
DAT
DAT
{
         ___  ____  __   ___  ____
        / __)(_  _)(  ) (  ,)(_  _)
        \__ \  )(  /__\  )  \  )(
        (___/ (__)(_)(_)(_)\_)(__)
}
DAT
DAT
{
         ___  ____  ___  ___
        / __)(_  _)(  _)(  ,\
        \__ \  )(   ) _) ) _/
        (___/ (__) (___)(_)
}
DAT
DAT
{
         ___  ____  __  ___
        / __)(_  _)/  \(  ,\
        \__ \  )( ( () )) _/
        (___/ (__) \__/(_)
}
DAT
DAT
{
         ___  _  _  ___
        / __)( )( )(  ,)
        \__ \ )()(  ) ,\
        (___/ \__/ (___/
}
DAT
DAT
{
         ___  _  _  ___  ____  ___  __  __
        / __)( \/ )/ __)(_  _)(  _)(  \/  )
        \__ \ \  / \__ \  )(   ) _) )    (
        (___/(__/  (___/ (__) (___)(_/\/\_)
}
DAT
DAT
{
         ____  __    __   __  __    ___ 
        (_  _)/  \  / _) / _)(  )  (  _)
          )( ( () )( (/\( (/\ )(__  ) _)
         (__) \__/  \__/ \__/(____)(___)
}
DAT '    See High Statement
DAT
{
         ____  _  _ 
        (_  _)( )( )
          )(   \\// 
         (__)  (__)
}
PRI StatTv

  ' TV OFF
  ' TV NTSC { SAVE }
  ' TV PAL  { SAVE }
  ' TV mode { SAVE }
  
  GetToken
  case token
    @opcOFF  : StatTvSetMode( true,  0                                   ) 
    @opcNTSC : StatTvSetMode( true,  tv#TV_MODE_NTSC | tv#TV_MODE_FORCED )
    @opcPAL  : StatTvSetMode( true,  tv#TV_MODE_PAL  | tv#TV_MODE_FORCED )
    other    : StatTvSetMode( false, ConstantNumber  | tv#TV_MODE_FORCED )
  
PRI StatTvSetMode( nGetToken, nMode ) | nSave

  if nGetToken
    GetToken
  if nSave := ( token == @opcSAVE )
    GetToken
  CheckEol
  tv.Close
  if nMode
    TvMode( nMode )
    TvCls           ' @@@@@@@@@@@@@@@@ move this to TV @@@@@@@@@@@@@@@@@ update version to 002
    ' Disable the console reporting so only goes to tv
    fileMode[0] <<= 4
    StatHelpMain
    fileMode[0] >>= 4
    
DAT
{
         _  _  __   ___   ___
        ( )( )(  ) (  ,) / __)
         \\// /__\  )  \ \__ \
         (__)(_)(_)(_)\_)(___/
}

PRI StatVars

  ' VARS
  
  GetToken
  CheckEol
  ListVars
  
DAT
{
         _    _  __   __  ____  __  _  _  ____
        ( \/\/ )(  ) (  )(_  _)/ _)( \( )(_  _)
         \    / /__\  )(   )( ( (_  )  (   )(
          \/\/ (_)(_)(__) (__) \__)(_)\_) (__)
}

PRI StatWaitCnt | n

  ' WAITCNT expr
  
  GetToken
  n := Expr
  CheckEol
  WaitCnt( n )

DAT
{
         _    _  __   __  ____  ___  ___   __            _    _  __   __  ____  ___  _  _  ___ 
        ( \/\/ )(  ) (  )(_  _)(  ,\(  _) /  \    ___   ( \/\/ )(  ) (  )(_  _)(  ,\( \( )(  _)
         \    / /__\  )(   )(   ) _/ ) _)( () )  (___)   \    / /__\  )(   )(   ) _/ )  (  ) _)
          \/\/ (_)(_)(__) (__) (_)  (___) \___\           \/\/ (_)(_)(__) (__) (_)  (_)\_)(___)
}

PRI StatWaitPxx | lhs, rhs, n, isWaitPeq

  ' WAITPEQ mask                                        Wait until pins all <> 0
  ' WAITPNE mask                                        Wait until any pins == 0
  
  ' WAITPEQ match, mask { , port }
  ' WAITPNE match, mask { , port }
  
  isWaitPeq := ( token == @opcWAITPEQ )
  GetToken
  lhs := Expr
  if token == @tagEOL
    rhs := lhs
    n := 0
  else
    Want( @symCOMMA )
    rhs := Expr
    if token == @symCOMMA
      GetToken
      n := Expr
    else
      n := 0

  CheckEol
  if isWaitPeq
    WaitPeq( lhs, rhs, n )
  else
    WaitPne( lhs, rhs, n )

DAT
{
         _    _  _  _  __  __    ___           _    _  ___  _  _  ___  
        ( \/\/ )( )( )(  )(  )  (  _)   ___   ( \/\/ )(  _)( \( )(   \ 
         \    /  )__(  )(  )(__  ) _)  (___)   \    /  ) _) )  (  ) ) )
          \/\/  (_)(_)(__)(____)(___)           \/\/  (___)(_)\_)(___/ 
}

PRI StatWhile

  ' WHILE expr
  ' WEND

  ' REPEAT
  ' WHILE expr

  GetToken
  if condWant[ condTop ] == @opcUNTIL
    CondPop( condWant[ condTop ] )
    if Expr
      nextPc := condAtPc[ condTop+1 ]
  else
    CondPush( Expr, @opcWEND )
  
PRI StatWend

  ' WHILE expr
  ' WEND

  GetToken
  CondPop( @opcWEND )
  if conditional[ condTop+1 ]
    nextPc := condAtPc[ condTop+1 ]
       
DAT
{
                                                                                                 
       .d8888b.                         888 d8b 888    d8b                            888          
      d88P  Y88b                        888 Y8P 888    Y8P                            888          
      888    888                        888     888                                   888          
      888         .d88b.  88888b.   .d88888 888 888888 888  .d88b.  88888b.   8888b.  888 .d8888b  
      888        d88""88b 888 "88b d88" 888 888 888    888 d88""88b 888 "88b     "88b 888 88K      
      888    888 888  888 888  888 888  888 888 888    888 888  888 888  888 .d888888 888 "Y8888b. 
      Y88b  d88P Y88..88P 888  888 Y88b 888 888 Y88b.  888 Y88..88P 888  888 888  888 888      X88 
       "Y8888P"   "Y88P"  888  888  "Y88888 888  "Y888 888  "Y88P"  888  888 "Y888888 888  88888P' 
                                                                                                   

}
CON

  COND_MAX = 10

VAR

  byte conditional[ COND_MAX ]
  long condWant[ COND_MAX ]
  long condAtPc[ COND_MAX ]
  byte condTop

PRI CondInit

  conditional[ condTop := 0 ] := true
  condWant[ condTop ] := @opcEND
      
PRI CondPush( n, wantNext )

  if ++condTop => COND_MAX
    Abort @aboNESTING_TOO_DEEP
  conditional[ condTop ] := n and conditional[ condTop-1 ]
  condWant[ condTop ] := wantNext
  condAtPc[ condTop ] := statPc
  
PRI CondPop( gotThis )

  if condTop =< 0
    Abort @aboNESTING_ERROR
  if condWant[ condTop-- ] <> gotThis
    Abort -condWant[ condTop+1 ]
    
DAT
{
             d8888                   d8b                                                   888    
            d88888                   Y8P                                                   888    
           d88P888                                                                         888    
          d88P 888 .d8888b  .d8888b  888  .d88b.  88888b.  88888b.d88b.   .d88b.  88888b.  888888 
         d88P  888 88K      88K      888 d88P"88b 888 "88b 888 "888 "88b d8P  Y8b 888 "88b 888    
        d88P   888 "Y8888b. "Y8888b. 888 888  888 888  888 888  888  888 88888888 888  888 888    
       d8888888888      X88      X88 888 Y88b 888 888  888 888  888  888 Y8b.     888  888 Y88b.  
      d88P     888  88888P'  88888P' 888  "Y88888 888  888 888  888  888  "Y8888  888  888  "Y888 
                                              888                                                 
                                         Y8b d88P                                                 
                                          "Y88P"                                                  

}
PRI Assignment | varPtr, varSize, getValue, putValue,  op, noOp

  varPtr  := VarRef
  noOp    := varPtr & $8000_0000
  varSize := ( varPtr >> 24 ) & $1F
  varPtr  &= $00FF_FFFF
  if token == @tagEOL or token == @symCOLON
    if noOp
      Abort -@symEQ
  else
    op := token
    GetToken
    putValue := getValue := PeekVar( varPtr, varSize )
    case op
      @symEQ, @symCOLONEQ :
        putValue := Expr
      @symADD,    @symSUB,   @symMPY, @symDIV, @symMOD, @symPCT, {
}     @symAND,    @symOR,    @symXOR,                            {
}     @symANDNOT, @symORNOT, @symXORNOT,                         {
}     @symNAND,   @symNOR,   @symXNOR,                           {
}     @symSHL,    @symSHR,   @symROL, @symROR, @symASR, @symREV, {
}     @symMIN,    @symMAX :
        case op
          @symPCT : op := @symMOD
        Want( @symEQ )   
        putValue := BinaryOp( getValue, op, Expr )
      other :
        Abort -@symEQ
    case varSize & $F
      1 : putValue &= $FF
      2 : putValue &= $FFFF
    if putValue <> getValue
      PokeVar( varPtr, varSize, putValue )

PRI UnaryAssignment

  Abort @aboUNIMPLEMENTED
         
DAT
{

     8888888888                                                     d8b                            
     888                                                            Y8P                            
     888                                                                                           
     8888888    888  888 88888b.  888d888 .d88b.  .d8888b  .d8888b  888  .d88b.  88888b.  .d8888b  
     888        `Y8bd8P' 888 "88b 888P"  d8P  Y8b 88K      88K      888 d88""88b 888 "88b 88K      
     888          X88K   888  888 888    88888888 "Y8888b. "Y8888b. 888 888  888 888  888 "Y8888b. 
     888        .d8""8b. 888 d88P 888    Y8b.          X88      X88 888 Y88..88P 888  888      X88 
     8888888888 888  888 88888P"  888     "Y8888   88888P'  88888P' 888  "Y88P"  888  888  88888P' 
                         888                                                                       
                         888                                                                       
                         888                                                                       

}
VAR

  byte mustBeConstantNumber
  
  long randomNumber

PRI ConstantNumber

  mustBeConstantNumber := true
  return SubExpr

PRI PositiveNonZeroNumber

  if ( result := Expr ) =< 0
    Abort @aboINVALID_VALUE
        
PRI PositiveNumber

  if ( result := Expr ) < 0
    Abort @aboINVALID_VALUE
      
PRI Expr

  mustBeConstantNumber := false
  return SubExpr

PRI SubExpr

  result := Term(0)
  if debug & DEBUG_SHOWEXPR
    Dbg( String( "EXP" ) )
    Out( "$" )
    Hex( result, 8 )
    Out( "," )
    Out( " " )
    Dec( result )
    Out( $0D )
    
PRI Term( depth ) | op

  if depth > 8
    return Factor

  result := Term( depth+1 )
  repeat
    op := 0
    case depth
      0 : case token
            @opcLOGOR, @opcLOGNOR, @opcLOGXNOR, @opcLOGNXOR         : op := token
      1 : case token
            @opcLOGAND, @opcLOGNAND                     : op := token 
      2 : case token
            @symEQ, @symEQEQ, @opcIS                    : op := @symEQ
            @symNE, @symNOTEQ                           : op := @symNE
            @symLT, @symGT                              : op := token
            @symLE, @symEL                              : op := @symLE
            @symGE, @symEG                              : op := @symGE
          if op
            GetToken
            return BinaryOp( result, op~, Term( depth+1 ) )
      3 : case token
            @symMIN, @opcMIN, @opcHIGHEST               : op := @symMIN 
            @symMAX, @opcMAX, @opcLOWEST                : op := @symMAX 
      4 : case token
            @symADD, @symSUB                            : op := token 
      5 : case token
            @symMPY, @symDIV                            : op := token 
            @symMOD, @symPCT, @opcMOD                   : op := @symMOD 
      6 : case token
            @symOR, @symXOR, @symNOR, @symXNOR          : op := token
      7 : case token
            @symAND, @symNAND                           : op := token 
      8 : case token
            @symSHL, @symSHR, @symROL, @symROR, @symASR : op := token
    if op
      GetToken
      result := BinaryOp( result, op, Term( depth+1 ) )
   
  while op

PRI BinaryOp( lhs, op, rhs )
   
  case op
    @symADD     : return lhs +   rhs
    @symSUB     : return lhs -   rhs
    @symMPY     : return lhs *   rhs
    @symDIV     : return lhs /   rhs
    @symMOD     : return lhs //  rhs
    @symAND     : return lhs &   rhs
    @symOR      : return lhs |   rhs
    @symXOR     : return lhs ^   rhs
    @symEQ      : return lhs ==  rhs
    @symNE      : return lhs <>  rhs
    @symLE      : return lhs =<  rhs
    @symLT      : return lhs <   rhs
    @symGE      : return lhs =>  rhs
    @symGT      : return lhs >   rhs
    @symSHL     : return lhs <<  rhs
    @symSHR     : return lhs >>  rhs
    @symROL     : return lhs <-  rhs
    @symROR     : return lhs ->  rhs
    @symASR     : return lhs ~>  rhs
    @symMIN     : return lhs #>  rhs
    @symMAX     : return lhs <#  rhs
    @opcLOGAND  : return lhs and rhs
    @opcLOGOR   : return lhs or  rhs
    @symANDNOT  : return lhs & ! rhs
    @symORNOT   : return lhs | ! rhs
    @symXORNOT  : return lhs ^ ! rhs
    @symNAND    : return !   ( lhs &   rhs )
    @symNOR     : return !   ( lhs |   rhs )
    @symXNOR    : return !   ( lhs ^   rhs )
    @opcLOGNAND : return not ( lhs and rhs )
    @opcLOGNOR  : return not ( lhs or  rhs )
    @opcLOGXOR  : return ( not lhs ) <> not ( rhs )
    @opcLOGXNOR : return ( not lhs ) == not ( rhs )
  Str( op )
  Abort @aboUNIMPLEMENTED

PRI Factor

  if @result > holeMrk
    holeMrk := @result

  case token
  
    @tagNUMBER :
      result := value
      GetToken
    @symLPARA :
      GetToken
      result := SubExpr
      Want( @symRPARA )
    @opcLOGNOT :
      GetToken
      result := not Term(2) ' Not factor ! Propeller precedence is a bit odd
    @symADD, @symSUB, @symNOT, @symBIT, @symSXB, @symSXW, @symABS, @symSQR, @symABS :
      result := FactorUnary
    @opcABS, @opcSQR, @opcMEM, @opcLSB, @opcMSB, @opcLSW, @opcMSW :
      result := FactorFunction( 1 )
    @opcCHIPVER :
      result := ChipVer
      GetToken
    @opcCLKFREQ :
      result := ClkFreq
      GetToken
    @opcTRUE :
      result := true
      GetToken
    @opcFALSE :
      result := false
      GetToken
    @opcIF :
      ' var := IF expr THEN trueExpr ELSE falseExpr
      GetToken
      if SubExpr
        Want( @opcTHEN )
        result := SubExpr
        Want( @opcELSE )
        SubExpr
      else
        Want( @opcTHEN )
        SubExpr
        Want( @opcELSE )
        result := SubExpr

    other :

      if mustBeConstantNumber
        Abort @aboCONSTANT_EXPECTED
      else

        case token
         
          @tagVAR, @tagNEW, @tagREG, @opcSPR, @opcBYTE, @opcWORD, @opcLONG, @opcEEPROM, @symINC, @symDEC :
            VarRef
            result := varValue
          @tagTXT :
            result := lastPc+1
            GetToken
          @symAT :
            GetToken
            case token
              @tagVAR, @tagNEW :
                result := GetVarSizeFromType( varType )
                result := ApplyVarIndex( CreateVar( result), result )
              @tagTXT :
                result := lastPc+1
                GetToken
              other :
                Abort -@tagVAR
          @opcGOTO :
            ' Returns address of line number ( for GOTO * ). Example ...
            '
            ' 10 v := GOTO 30 : GOTO * v
            ' 20 END
            ' 30 PRINT "Tada!"
            result := PreCachedLineNumber
          @opcCOLUMN :
            result := TvGetCurrentColumn
            GetToken
          @opcINKEY :
            result := InGetAny
            GetToken
          @opcRND :
            result := ? randomNumber
            GetToken
          @opcROW :
            result := TvGetCurrentRow
            GetToken
          @opxVAR :
            ' := VAR(n,m) ' returns information on a variable
            result := FactorFunction( 2 )
         
          other :
            Abort @aboFACTOR_EXPECTED

PRI FactorUnary | op

  op := token
  GetToken
  result := Factor
  case op
    @symABS : || result
    @symADD :
    @symBIT : |< result
    @symNOT : !  result
    @symSQR : ^^ result
    @symSUB : -  result
    @symSXB : ~  result
    @symSXW : ~~ result
    other   : Abort @aboUNIMPLEMENTED
      
PRI FactorFunction( nCount ) | op, n[3]

  op := token
  GetToken
  Want( @symLPARA )
  result := n[ --nCount ] := SubExpr
  repeat while --nCount > 0
    Want( @symCOMMA )
    n[ nCount ] := SubExpr
  Want( @symRPARA )
  case op
    @opcABS  : || result
    @opcLSB  : result &= $FF
    @opcLSW  : result &= $FFFF
    @opcMEM  : result := MemInfo( result )
    @opcMSB  : result := ( result >> 8 ) & $FF
    @opcMSW  : result >>= 16
    @opcSQR  : ^^ result
    @opxVAR  : result := VarFunc( n[0], n[1] )
    other    : Abort @aboUNIMPLEMENTED

DAT
{

     888     888                    888    888                        888 888 d8b                   
     888     888                    888    888                        888 888 Y8P                   
     888     888                    888    888                        888 888                       
     Y88b   d88P 8888b.  888d888    8888888888  8888b.  88888b.   .d88888 888 888 88888b.   .d88b.  
      Y88b d88P     "88b 888P"      888    888     "88b 888 "88b d88" 888 888 888 888 "88b d88P"88b 
       Y88o88P  .d888888 888        888    888 .d888888 888  888 888  888 888 888 888  888 888  888 
        Y888P   888  888 888        888    888 888  888 888  888 Y88b 888 888 888 888  888 Y88b 888 
         Y8P    "Y888888 888        888    888 "Y888888 888  888  "Y88888 888 888 888  888  "Y88888 
                                                                                                888 
                                                                                           Y8b d88P 
                                                                                            "Y88P"  

}
PRI VarRef | preInc, anyOps, varPtr, varSize, getValue, putValue

  anyOps := preInc := 0
    
  repeat while ( token == @symINC ) or ( token == @symDEC )
    anyOps := true
    if token == @symINC
      preInc++
    else
      preInc--
    GetToken

  case token   
    @tagVAR, @tagNEW :
      varSize := GetVarSizeFromType( varType )
      varPtr  := ApplyVarIndex( CreateVar(varSize), varSize )
      varSize := TypeModifier( @varPtr, varSize )
    @tagREG :
      varPtr  := value
      varSize := 0
      GetToken
    @opcBYTE, @opcWORD, @opcLONG, @opcSPR :
      case token
        @opcSPR  : varSize := 0
        @opcBYTE : varSize := 1
        @opcWORD : varSize := 2
        @opcLONG : varSize := 4
      varPtr := ApplyVarIndex( 0, 1 )
    @opcEEPROM :
      varPtr := ApplyVarIndex( 0, 1 )
      ' Determine the size of EEPROM[] if there's no modifier then we get back $15 which we know does
      ' not make sense so we know there was no modifier so we treat it as a byte. If there is a modifier
      ' the we'll get back $11, $12 or $14 and that's okay.
      varSize := $10 + TypeModifier( @varPtr, 5 )
      if varSize == $15
        varSize := $11
    @opcRND :
      GetToken
      varPtr  := @randomNumber
      varSize := TypeModifier( @varPtr, 4 )
    other :
      Abort -@tagVAR

  if token == @symDOT
    Abort @aboMODIFIER_ERROR
 
  putValue := ( varValue := ( getValue := PeekVar( varPtr, varSize ) )+ preInc )
      
  if token == @symSXB
    GetToken
    anyOps := true
    putValue := 0
  else
    if token == @symSXW
      GetToken
      anyOps := true
      putValue := -1
      
  repeat while ( token == @symINC ) or ( token == @symDEC )
    anyOps := true
    if token == @symINC
      putValue++
    else
      putValue--
    GetToken

  if anyOps
    case varSize and $F
      1 : putValue &= $FF
      2 : putValue &= $FFFF
    if putValue <> getValue      
      PokeVar( varPtr, varSize, putValue ) 
  else
    varPtr |= $8000_0000

  if debug & DEBUG_SHOWVARDEF
    OnNewLine
    Str( String( "#VAR " ) )
    Dec( getValue )
    if anyOps
      Out( " " )
      Dec( varValue )
      Out( " " )
      Dec( putValue )
    Out( $0D )
      
  result := varSize << 24 | varPtr

PRI ApplyVarIndex( nPtr, nSize )

  GetToken
  if token == @symLPARA 
    GetToken
    nPtr += PositiveNumber * nSize
    Want( @symRPARA )
  else
    if nPtr == 0
      if token <> @symLBRACKET
        Abort -@symLBRACKET 
    repeat while token == @symLBRACKET
      GetToken
      nPtr += PositiveNumber * nSize
      Want( @symRBRACKET )
      nSize := 1

  result := nPtr

PRI TypeModifier( nAtPtr, nSize )

  ' .LSB
  ' .MSB
  ' .LSW
  ' .MSW

  ' .BYTE
  ' .WORD
  ' .LONG
  
  repeat while token == @symDOT
    GetToken
    case token
    
      @opcBYTE, @opcLSB :
        nSize := 1

      @opcWORD, @opcLSW :
        if nSize < 2
          Abort @aboMODIFIER_ERROR
        nSize := 2

      @opcLONG :
        if nSize < 4
          Abort @aboMODIFIER_ERROR
        nSize := 4
        
      @opcMSB :
        if nSize => 4
          nSize := 1
          long[ nAtPtr ] += 3
        else
          if nSize < 2
            Abort @aboMODIFIER_ERROR
          nSize := 1
          long[ nAtPtr ]++

      @opcMSW :
        if nSize < 4
          Abort @aboMODIFIER_ERROR
        nSize := 2
        long[ nAtPtr ] += 2
        
      other :
        Abort @aboMODIFIER_ERROR

    GetToken

  result := nSize
  
        
PRI PeekVar( nPtr, nSize )

  if @result > holeMrk
    holeMrk := @result

  case nSize
  
    0   : result := SPR[ nPtr & $F ]
    
    1   : result := byte[ nPtr ]
    2   : result := byte[ nPtr+1 ] << 8  | byte[ nPtr ]
    4   : result := byte[ nPtr+3 ] << 24 | byte[ nPtr+2 ] << 16 | byte[ nPtr+1 ] << 8 | byte[ nPtr ]
    
    $11 : result := i2c.ReadByte( nPtr )
    $12 : result := i2c.ReadWord( nPtr )
    $14 : result := i2c.ReadLong( nPtr )
        
PRI PokeVar( nPtr, nSize, n )

  case nSize
  
    0   : SPR[ nPtr & $F ]  := n
    
    1   : byte[ nPtr   ] := n
    
    2   : byte[ nPtr   ] := n
          byte[ nPtr+1 ] := n >> 8

    4   : byte[ nPtr   ] := n
          byte[ nPtr+1 ] := n >> 8
          byte[ nPtr+2 ] := n >> 16
          byte[ nPtr+3 ] := n >> 24
          
    $11 : if i2c.ReadByte( nPtr ) <> n
            i2c.WriteByte( nPtr, n )
    $12 : if i2c.ReadWord( nPtr ) <> n
            i2c.WriteWord( nPtr, n )
    $14 : if i2c.ReadLong( nPtr ) <> n
            i2c.WriteLong( nPtr, n )
      
DAT
{

           .d8888b.           888       88888888888       888                                 
          d88P  Y88b          888           888           888                                 
          888    888          888           888           888                                 
          888         .d88b.  888888        888   .d88b.  888  888  .d88b.  88888b.  .d8888b  
          888  88888 d8P  Y8b 888           888  d88""88b 888 .88P d8P  Y8b 888 "88b 88K      
          888    888 88888888 888           888  888  888 888888K  88888888 888  888 "Y8888b. 
          Y88b  d88P Y8b.     Y88b.         888  Y88..88P 888 "88b Y8b.     888  888      X88 
           "Y8888P88  "Y8888   "Y888        888   "Y88P"  888  888  "Y8888  888  888  88888P' 


}
VAR

  long token
  long value
  byte varType
  long varValue
  byte tokenId

  long pushedToken
  long pushedPc

  long getTokenNumberValue
  
PRI GetTokenPushState

  pushedToken   := token
  pushedPc      := pc
  
PRI GetTokenPopState

  token   := pushedToken
  pc      := pushedPc
  
PRI GetToken

  repeat
    case result := SingleToken
      @tagBIN, @tagHEX, @tagQUD :
        result := false
      @tagREM :
        repeat while ( result := SingleToken ) <> @tagEOL
  until result
          
PRI SingleToken

  case result := token := opcLookupTable[ tokenId := byte[ lastPc := pc++ ] ]
    @tagBYTE, @tagWORD, @tagTRIP, @tagLONG :
      pc := GetTokenNumber( pc, token )
      value := getTokenNumberValue
    @tagVAR, @tagNEW :
      pc := GetTokenCachedValue( pc )
      repeat while ( ( varType := byte[ pc++ ] ) & $80 )
    @tagREG :
      value := byte[ pc++ ]
    @tagTXT :
      repeat while ( byte[ pc++ ] & $80 )
    @tagREM :
      repeat while ( result := byte[ pc++ ] ) <> @tagEOL
    @opcGOTO, @opcGOSUB :
      pc := GetTokenCachedValue( pc )
    @tagEOF :
      Abort @aboFELL_OFF_END

  if debug & constant( DEBUG_SHOWTOKEN | DEBUG_ALLTOKENS )
    if debug & DEBUG_SHOWTOKEN
      Dbg( String( "TOK" ) )
      ListToken( lastPc, token )
    else
      Str( token )

PRI GetTokenNumber( nPc, nToken )

  case || nToken
    @tagBYTE :
      getTokenNumberValue := byte[ nPc++ ]
    @tagWORD :
      getTokenNumberValue := byte[ nPc++ ] << 8  | byte[ nPc++ ]
    @tagTRIP :
      getTokenNumberValue := byte[ nPc++ ] << 16 | byte[ nPc++ ] << 8  | byte[ nPc++ ]
    @tagLONG :
      getTokenNumberValue := byte[ nPc++ ] << 24 | byte[ nPc++ ] << 16 | byte[ nPc++ ] << 8 | byte[ nPc++ ]
    other :
      nPc := 0

  if nPc and ( nToken > 0 )
    token := @tagNUMBER

  return nPc

PRI GetTokenCachedValue( nPc )

  value := byte[ nPc++ ] << 8 | byte[ nPc++ ]

  if IsPropellerMkII
    value := value << 8 | byte[ nPc++ ]

  return nPc
        
PRI SetTokenCachedValue( nPc, n )

  if IsPropellerMkII
    byte[ nPc++ ] := n >> 16

  byte[ nPc++ ] := n >> 8
  byte[ nPc++ ] := n

  return nPc

PRI SkipTokenCachedValue( nPc )

  if IsPropellerMkII
    return nPc + 3
  else  
    return nPc+ 2
                       
DAT
{

            888      d8b                      8888888888     888 d8b 888                    
            888      Y8P                      888            888 Y8P 888                    
            888                               888            888     888                    
            888      888 88888b.   .d88b.     8888888    .d88888 888 888888 .d88b.  888d888 
            888      888 888 "88b d8P  Y8b    888       d88" 888 888 888   d88""88b 888P"   
            888      888 888  888 88888888    888       888  888 888 888   888  888 888     
            888      888 888  888 Y8b.        888       Y88b 888 888 Y88b. Y88..88P 888     
            88888888 888 888  888  "Y8888     8888888888 "Y88888 888  "Y888 "Y88P"  888     

}

CON

  CTRL_A = $01
  CTRL_B = $02
  CTRL_C = $03
  CTRL_D = $04
  CTRL_E = $05
  CTRL_F = $06
  CTRL_G = $07
  CTRL_H = $08
  CTRL_I = $09
  CTRL_J = $0A
  CTRL_K = $0B
  CTRL_L = $0C
  CTRL_M = $0D
  CTRL_N = $0E
  CTRL_O = $0F
  CTRL_P = $10
  CTRL_Q = $11
  CTRL_R = $12
  CTRL_S = $13
  CTRL_T = $14
  CTRL_U = $15
  CTRL_V = $16
  CTRL_W = $17
  CTRL_X = $18
  CTRL_Y = $19
  CTRL_Z = $1A

  ESCAPE = $1B
  
VAR

  long rnd

  byte cmdLine[ 100 ]
  byte chIdx

  byte cmdToks[ 100]
  
PRI CommandLine | n

  repeat
    Out( ">" )
    chIdx := 0
    repeat
      if rxBreak~ or kbBreak~
        Str( String( "<BREAK>",$0D,">" ) ) '@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        RxFlush
        KbFlush
        chIdx := 0
      else
        if ( n := InGetAny ) > 0
          case n
            CTRL_C :                                    ' ^C - Cancel
              Str( String( "^C",$0D,">" ) )
              chIdx := 0                                ' ^E - Copy to End of Buffer
            CTRL_E :
              repeat while cmdLine[ chIdx ] <> $0D 
                Out( cmdLine[ chIdx++] )
            CTRL_H :                                    ' ^H - Backspace
              if chIdx
                cmdLine[ --chIdx ] := $0D
                Str( String( "^H",$0D,">" ) )
                chIdx := 0
                repeat while cmdLine[ chIdx ] <> $0D 
                  Out( cmdLine[ chIdx++] )
            CTRL_R :                                    ' ^R - Cursor Right ( copy )
              if cmdLine[ chIdx ] <> $0D
                out( cmdLine[ chIdx++] )
            other :
              Out( n )
              cmdLine[ chIdx++ ] := n
    until n == $0D
    if ( n := \Parse( @cmdLine, @cmdToks )  )
      ' Failed parsing so give an error message
      Str( n )                            
      Out( $0D )
    else
      DoTheEdit

PRI DoTheEdit | nPc, nToken, nStartLinePc, nNextLinePc, nSize
  
  case nToken := opcLookupTable[ byte[ nPc := @cmdToks ] ]

    @tagEOL, @tagREM :
      
    @tagBYTE, @tagWORD, @tagTRIP, @tagLONG :

      nPc := GetTokenNumber( nPc+1, nToken )
      if getTokenNumberValue =< 0 or getTokenNumberValue > 99999
        Str( @aboINVALID_LINENUMBER )
        Out( $0D )
      else

        nStartLinePc := FindLineNumberPc( getTokenNumberValue )

        if nStartLinePc > 0
          if debug & DEBUG_PARSE
            Dbg( String( "DEL" ) )
            Dec( getTokenNumberValue )
            Out( $0D )
          nNextLinePc := SkipLine( nStartLinePc )
          nSize := nNextLinePc - nStartLinePc
          ByteMove( nStartLinePc, nNextLinePc, codeTop - nNextLinePc + 1 )
          codeTop -= nSize
          ' @@@@@ THIS CAUSES A CRASH
          'if codeBot =< codeTop
          '  codeTop := codeBot-1
                  
        || nStartLinePc

        if opcLookupTable[ byte[ nPc ] ] <> @tagEOL
          if debug & DEBUG_PARSE
            Dbg( String( "ADD" ) )
            ListLine( @cmdToks )
          nNextLinePc := SkipLine( @cmdToks )
          nSize := nNextLinePc - @cmdToks
          ByteMove( nStartLinePc + nSize, nStartLinePc, codeTop -  nStartLinePc + 1 )
          ByteMove( nStartLinePc, @cmdToks, nSize )
          ResetCode

    other :

      if debug & DEBUG_PARSE
        Dbg( String( "RUN" ) )
        ListLine( @cmdToks )
      Execute( @cmdToks )
    
DAT
{

         888      d8b                      8888888b.                                            
         888      Y8P                      888   Y88b                                           
         888                               888    888                                           
         888      888 88888b.   .d88b.     888   d88P 8888b.  888d888 .d8888b   .d88b.  888d888 
         888      888 888 "88b d8P  Y8b    8888888P"     "88b 888P"   88K      d8P  Y8b 888P"   
         888      888 888  888 88888888    888       .d888888 888     "Y8888b. 88888888 888     
         888      888 888  888 Y8b.        888       888  888 888          X88 Y8b.     888     
         88888888 888 888  888  "Y8888     888       "Y888888 888      88888P'  "Y8888  888     
                                                                                                
}
CON

  #0
  CHAR_TYPE_EOL
  CHAR_TYPE_VAR
  CHAR_TYPE_NUM
  CHAR_TYPE_NUL
  CHAR_TYPE_ZRO
  CHAR_TYPE_AMP
  CHAR_TYPE_DLR
  CHAR_TYPE_PCT
  CHAR_TYPE_SYM
  CHAR_TYPE_TXT
  CHAR_TYPE_REM
  
  CHAR_MORE_VAR = $01_00
  CHAR_MORE_TYP = $02_00
  CHAR_MORE_BIN = $04_00
  CHAR_MORE_QUD = $08_00
  CHAR_MORE_DEC = $10_00
  CHAR_MORE_HEX = $20_00

  CHAR_MORE_NUM = CHAR_MORE_BIN | CHAR_MORE_QUD | CHAR_MORE_DEC
  
  NAM_LENGTH = 8

VAR

  word charTypes[ $7F ]
  byte ch
  word chType

  byte namText[ NAM_LENGTH + 2 ]
  byte namIdx 

  long chPtr
  
PRI ParseInit

  CharInitSet( $00, $40, CHAR_TYPE_NUL, 0 )
  CharInitSet( $21, $7F, CHAR_TYPE_SYM, 0 )

  CharInitOne( $0D     , CHAR_TYPE_EOL, 0 )
  CharInitOne( $22     , CHAR_TYPE_TXT, 0 )

  CharInitSet( "A", "Z", CHAR_TYPE_VAR, CHAR_MORE_VAR )
  CharInitSet( "a", "z", CHAR_TYPE_VAR, CHAR_MORE_VAR )

  CharInitSet( "A", "F", CHAR_TYPE_VAR, CHAR_MORE_HEX )
  CharInitSet( "a", "f", CHAR_TYPE_VAR, CHAR_MORE_HEX )

  CharInitSet( "0", "9", CHAR_TYPE_NUM, CHAR_MORE_DEC | CHAR_MORE_HEX )
  CharInitSet( "0", "3", CHAR_TYPE_NUM, CHAR_MORE_QUD | CHAR_MORE_DEC | CHAR_MORE_HEX )
  CharInitSet( "0", "1", CHAR_TYPE_NUM, CHAR_MORE_BIN | CHAR_MORE_QUD | CHAR_MORE_DEC | CHAR_MORE_HEX )
  CharInitOne( "0"     , CHAR_TYPE_ZRO, CHAR_MORE_BIN )

  CharInitOne( "&"     , CHAR_TYPE_AMP, CHAR_MORE_TYP )
  CharInitOne( "%"     , CHAR_TYPE_PCT, CHAR_MORE_TYP )
  CharInitOne( "$"     , CHAR_TYPE_DLR, CHAR_MORE_TYP )

  CharInitOne( "_"     , CHAR_TYPE_SYM, CHAR_MORE_VAR | CHAR_MORE_BIN | CHAR_MORE_QUD | CHAR_MORE_DEC | CHAR_MORE_HEX )

  CharInitOne( "'"     , CHAR_TYPE_REM, 0 )

PRI CharInitOne( n, nType, nMore )

  CharInitSet ( n, n, nType, nMore )
  
PRI CharInitSet ( nFrom, nTo, nType, nMore )

  repeat ch from nFrom to nTo
    charTypes[ ch ] &= ! $FF
    charTypes[ ch ] |= nMore | nType

PRI Parse( n1, n2 )

  chPtr := n1
  pc    := n2
  
  GetChar
  repeat
    ParseWord
  until token == CHAR_TYPE_EOL
  
PRI ParseWord

  repeat while ( chType & $FF ) == CHAR_TYPE_NUL
    GetChar

  value := 0
  namText[ namIdx := 0 ] := 0

  case ( token := chType & $FF )

    CHAR_TYPE_VAR :

        if debug & DEBUG_PARSE    
          Str( String( "VAR " ) )

        namIdx := 0
        AddCharThenGetChar
        repeat while chType & constant( CHAR_MORE_VAR | CHAR_MORE_NUM )
          AddCharThenGetChar
        if MatchWithToken( @opc_LIST_START )
          PushOpc( token )
        else
          if MatchWithToken( @reg_LIST_START ) 
            PushReg( value )
          else          
            if chType & CHAR_MORE_TYP
              namIdx <#= ( NAM_LENGTH - 1 )
              AddCharThenGetChar
            if MatchWithToken( @opr_LIST_START )
              PushOpc( token )
            else
              PushVar( @namText )
            
        if debug & DEBUG_PARSE    
          Str( token )
        
    CHAR_TYPE_NUM :

        ParseNumber( -10, CHAR_MORE_DEC )

    CHAR_TYPE_ZRO :

        GetChar 
        case ch
          "B", "b" : ParseNumber( 2,  CHAR_MORE_BIN )
          "X", "x" : ParseNumber( 16, CHAR_MORE_HEX )
          other    : if chType & CHAR_MORE_HEX ' Yes - this should be HEX
                       ParseNumber( -10, CHAR_MORE_DEC )
                     else
                       if debug & DEBUG_PARSE    
                         Str( String( "NUM 0" ) )
                       PushNum( 0 )

    CHAR_TYPE_AMP :

        GetChar
        case ch
          "B", "b" : ParseNumber( 2,  CHAR_MORE_BIN )
          "X", "x" : ParseNumber( 16, CHAR_MORE_HEX )
          "H", "h" : ParseNumber( 16, CHAR_MORE_HEX )
          other    : PushOpc( @symAND )

    CHAR_TYPE_PCT :

      GetChar
      if ch == "%"
        ParseNumber( 4,  CHAR_MORE_QUD )
      else
        if chType & CHAR_MORE_BIN
          ParseNumber( -2,  CHAR_MORE_BIN )
        else
          PushOpc( @symPCT )
          
    CHAR_TYPE_DLR :

      ParseNumber( 16,  CHAR_MORE_HEX )

    CHAR_TYPE_TXT :

      if debug & DEBUG_PARSE    
        Str( String( "TXT " ) )

      PushOpc( @tagTXT)
      repeat
        GetChar
        repeat until ( ch == $22 ) or ( ( chType & $FF ) == CHAR_TYPE_EOL )
          AddLast
          GetChar
        if ch <> $22
          Abort @aboUNTERMINATED_STRING
        else
          GetChar
          if ch == $22
            AddLast
      until ch <> $22
      namIdx |= $80
      AddLast

    CHAR_TYPE_REM :

      if debug & DEBUG_PARSE    
        Str( String( "REM " ) )
      PushOpc( @tagREM)
      GetChar
      repeat while ( chType & $FF ) == CHAR_TYPE_NUL
        GetChar
      repeat until ( chType & $FF ) == CHAR_TYPE_EOL
        AddLast
        GetChar
      namIdx |= $80
      AddLast        

    CHAR_TYPE_EOL :

      if debug & DEBUG_PARSE    
        Str( String( "EOL" ) )
      PushOpc( @tagEOL )
      PushOpc( @tagEOF )
          
    other : ParseSymbol
  
  if debug & DEBUG_PARSE    
    Out( $0D )

PRI ParseSymbol

  if debug & DEBUG_PARSE    
    Str( String( "SYM " ) )
  namIdx := 0
  AddCharThenGetChar

  case namText[0]
    "-" : ParseSymbolList( String( "->"    ) )
    "!" : ParseSymbolList( String( "="     ) )
    "#" : ParseSymbolList( String( ">"     ) )
    "&" : ParseSymbolList( String( "/"     ) )
    "." : ParseSymbolList( String( "."     ) )
    "/" : ParseSymbolList( String( "&/^|"  ) )
    ":" : ParseSymbolList( String( "="     ) )
    "^" : ParseSymbolList( String( "/^"    ) )
    "|" : ParseSymbolList( String( "|/<"   ) )
    "~" : ParseSymbolList( String( "~>"    ) )
    "+" : ParseSymbolList( String( "+"     ) )
    "<" : ParseSymbolList( String( "-#<=>" ) )
    "=" : ParseSymbolList( String( "<=>"   ) )
    ">" : ParseSymbolList( String( "<>="   ) )

  if MatchWithToken( @sym_LIST_START )
    PushOpc( token )
  else
    Abort @aboINVALID_SYMBOL

PRI ParseSymbolList( strPtr )

  repeat
    if ch == byte[ strPtr ]
      AddCharThenGetChar
      return
  until byte[ ++strPtr ] == 0
  
PRI ParseNumber( nRadix, nMore )

  if debug & DEBUG_PARSE
    Str( String( "NUM " ) )

  case numberRadix := || nRadix
    2  : PushOpc( @tagBIN )
    4  : PushOpc( @tagQUD )
    16 : pushOpc( @tagHEX )
    
  if nRadix => 0
    GetChar

  if ( chType & nMore ) == 0
    Abort @aboINVALID_NUMBER
    
  repeat while chType & nMore
    AddNumberThenGetChar
    
  if chType & CHAR_MORE_HEX
    Abort @aboINVALID_NUMBER 
  if ch == "."
    if numberRadix == 10
      Abort @aboNO_REALS
    else
      Abort @aboINVALID_DOT

  PushNum( value )
  
PRI GetChar

  if ( ch := byte[ chPtr ] & $7F ) <> $0D
    chPtr++
  chType := charTypes[ ch ]
    
PRI AddNumberThenGetChar
  if ch <> "_"
    value *= numberRadix
    case ch
      "A".."F" : value += ch - "A" + $A
      "a".."f" : value += ch - "a" + $A
      other    : value += ch - "0"
  GetChar 

PRI AddCharThenGetChar

  namText[ namIdx++ <# NAM_LENGTH ] := ch
  namText[ namIdx   <# NAM_LENGTH ] := 0
  GetChar

PRI AddLast

  if namIdx
    byte[ pc++ ] := namIdx ^ $80
  namIdx := ch
  
PRI MatchWithToken( n )

  value := 0
  repeat while byte[ n ]
    if MatchToken( n )
      return token := n
    n += StrSize(n) + 1
    value++
    
PRI MatchToken( n ) | nPtr

  nPtr := @namText
  repeat StrSize(n)+1
    if UcaseViaPtr( nPtr++ ) <> UcaseViaPtr( n++ )
      return false
  return true

PRI UcaseViaPtr( n )

  result := byte[ n ]
  if result => "a" and result =< "z"
    result := result + "A" - "a"

DAT
{                                                                                              


          8888888888                                      888    888    d8b                   
          888                                             888    888    Y8P                   
          888                                             888    888                          
          8888888  .d88b.  888d888 88888b.d88b.   8888b.  888888 888888 888 88888b.   .d88b.  
          888     d88""88b 888P"   888 "888 "88b     "88b 888    888    888 888 "88b d88P"88b 
          888     888  888 888     888  888  888 .d888888 888    888    888 888  888 888  888 
          888     Y88..88P 888     888  888  888 888  888 Y88b.  Y88b.  888 888  888 Y88b 888 
          888      "Y88P"  888     888  888  888 "Y888888  "Y888  "Y888 888 888  888  "Y88888 
                                                                                          888 
                                                                                     Y8b d88P 
                                                                                      "Y88P"  
}
VAR

  byte numberRadix
  byte numberWidth

PRI OnNewLine

  if notHadCrLf
    Out( $0D )

PRI Mhz( n )

  n := CLKFREQ / 500_000
  Dec( ( n >> 1 ) + ( n & 1 ) )

PRI Dkb( n )

  if n
    if ( n & 1023 )
      Dec( n )
      if n => 1024
        Str( String( " ( " ) )
        if n & 512
          Out( "<" )
          n += 512
        else
          Out( ">" )
        Out( " " )
        Dec( n >> 10 )
        Str( String( "K )" ) )
    else
      Dec( n >> 10 )
      Out( "K" )
  else
    Str( String( "None" ) )

PRI Spc( n )

  repeat n
    Out( " " )
    
PRI Tab( n )

  if notHadCrLf => n
    Out( $0D )
  repeat while notHadCrLf+1 < n
    Out( " " )
    
PRI Dec( n )

  if fileHandle => 0
    OutNumberFormat( n, 10, 0 )
  
PRI Bin( n, s )

  if fileHandle => 0
    OutNumberFormat( n, 2, s )

PRI Adr( n )

  Hex( n, 4 | ( IsPropellerMkII & 2 ) )  

PRI Hex( n, s )

  if fileHandle => 0
    OutNumberFormat( n, 16, s )

PRI Num( n, s )

  if fileHandle => 0
    OutNumberFormat( n, 10, s )
    
PUB OutNumberFormat( n, radix, width )

  numberRadix := radix
  numberWidth := width
  OutNumber(n)

PUB OutNumber( n ) |  digits, k

    if n == 0 
      repeat numberWidth #> 1
        Out("0")
    else

      case numberRadix

        2  : OutRadixNumber(n,31,$1,1,32)
        4  : OutRadixNumber(n,30,$3,2,16)
        8  : OutRadixNumber(n,30,$7,3,11)
        16 : OutRadixNumber(n,28,$F,4,8)

        other : k := 1_000_000_000
                digits := 11
                if n < 0
                  Out("-")
                  n := -n
                  digits--
                repeat while k > n
                  k /= 10
                  digits--
                repeat while numberWidth => digits++
                  Out("0")
                repeat while k <> 0
                  OutDigit( ( n / k ) // 10 )
                  k /= 10

  numberRadix := 10
  
PUB OutRadixNumber(n,shift,mask,decr,digits)

  repeat while ( n >> shift ) == 0
    shift -= decr
    digits--
  repeat while numberWidth > digits++
    Out("0")
  repeat while shift => 0
    OutDigit( ( n >> shift ) & mask )
    shift -= decr

PUB OutDigit( n )

  if ( n += "0" ) > "9"
    n := n - "9" + "A" - 1
  Out( n )

PRI StrChoice( n , nCount )

  repeat nCount
    n += StrSize(n)+1
    
  Str( n )
  
PRI Str( n )

  if fileHandle => 0
    repeat StrSize( n )
      Out( byte[ n++ ] )

DAT
{

     8888888888 d8b 888             888    888                        888 888 d8b                   
     888        Y8P 888             888    888                        888 888 Y8P                   
     888            888             888    888                        888 888                       
     8888888    888 888  .d88b.     8888888888  8888b.  88888b.   .d88888 888 888 88888b.   .d88b.  
     888        888 888 d8P  Y8b    888    888     "88b 888 "88b d88" 888 888 888 888 "88b d88P"88b 
     888        888 888 88888888    888    888 .d888888 888  888 888  888 888 888 888  888 888  888 
     888        888 888 Y8b.        888    888 888  888 888  888 Y88b 888 888 888 888  888 Y88b 888 
     888        888 888  "Y8888     888    888 "Y888888 888  888  "Y88888 888 888 888  888  "Y88888 
                                                                                                888 
                                                                                           Y8b d88P 
                                                                                            "Y88P"  
}
DAT
{
        File Handling as a bit of a misnomer at present; it is really serial port routing because that
        is all that it handles. A pin may be opened for serial input or output, only one pin may be used
        for serial at a time and only ne pin may be used with any file handle. To use the same pin in a
        different way requires the file to be closed.

        The console is a special case ( file handle #0 ). Everything sent to the TV is also sent up the
        pin open on #0 and everything coming in on #0 is merged with keyboard data. This mode is set
        when first powered up and when the program stops. The console is automatically disconnected when
        the program does something which makes the connection invalid or incompatible with what has been
        specified.

        In the fullness of time, file handling will also include redirecting output to real file streams
        such as SD Card or Eeprom and allow input from the same.
}
CON

  FILE_MAX        = 7           ' Must be power of 2 minus 1, 31 maximum ( ie 1, 3, 7, 15, 31 )
  
  FILE_MODE_CLOSED     = %000
  FILE_MODE_INPUT      = %001
  FILE_MODE_OUTPUT     = %010
  FILE_MODE_OPEN       = %011
  FILE_MODE_CONSOLE    = %111
  
  PINS_NOT_OUTPUT = |< RX_PROP_PIN + |< KB_DAT_PIN + |< KB_CLK_PIN + ( %111 << TV_PIN )
  PINS_NOT_INPUT  = |< TX_PROP_PIN + |< KB_DAT_PIN + |< KB_CLK_PIN + ( %111 << TV_PIN )
  
VAR

  long fileHandle
  
  byte fileMode       [ FILE_MAX + 1 ]
  byte filePinNumber  [ FILE_MAX + 1 ]
  long fileBitTime    [ FILE_MAX + 1 ]
  byte fileParityType [ FILE_MAX + 1 ]
  byte fileDataBits   [ FILE_MAX + 1 ]
  byte fileStopBits   [ FILE_MAX + 1 ]
  
  byte consoleInitialised
  long notHadCrLf
  
PRI Out( n )

  if fileHandle => 0
    if fileHandle == 0
      tv.Out( n )
      if n == $0D
        notHadCrlf := 0
      else
        notHadCrLf++
      if fileMode[ 0 ] & FILE_MODE_OUTPUT
        TxOut( n )
    else
      if not ( fileMode[ fileHandle ] & FILE_MODE_OUTPUT )
        Abort @aboBAD_FILE_MODE
      TxOut( n )

PRI FileOpenConsole

  fileHandle := 0

  if consoleInitialised~~ == 0
  
    TxInit

    if TX_PIN => 0
      FileOpen( TX_PIN, BAUD_RATE, PARITY_NONE, DATA_8, STOP_1, FILE_MODE_CONSOLE, fileHandle ) 
      TxOut( $0D )

    if RX_PIN => 0
      RxInit

PRI FileOpen( nPinNumber, nBaudRate, nParityType, nDataBits, nStopBits, nMode, f ) | n, txInvert

  if nMode <> FILE_MODE_CONSOLE
    if nMode & FILE_MODE_INPUT
      if PINS_NOT_INPUT & ( |< nPinNumber )
        Abort @aboPIN_IN_USE
    else
      if PINS_NOT_OUTPUT & ( |< nPinNumber )
        Abort @aboPIN_IN_USE

  if fileMode[f] & FILE_MODE_OPEN
    if fileMode[ n ] == FILE_MODE_CONSOLE
      FileClose(n)
    else
      Abort @aboFILE_OPEN
    
  repeat n from 0 TO FILE_MAX
    if ( fileMode[n] & FILE_MODE_OPEN ) and ( filePinNumber[n] == nPinNumber )
      if fileMode[ n ] == FILE_MODE_CONSOLE
        FileClose(n)
      else
        Abort @aboPIN_IN_USE
    if ( nMode & FILE_MODE_INPUT ) and ( fileMode[n] & FILE_MODE_INPUT )
      if fileMode[ n ] == FILE_MODE_CONSOLE
        FileClose(n)
      else
        Abort @aboINPUT_IN_USE

  fileMode[f]       := nMode
  filePinNumber[f]  := nPinNumber    
  fileBitTime[f]    := FileOpenSetDefault( CLKFREQ / || nBaudRate, fileBitTime[f],    CLKFREQ / BAUD_RATE ) 
  fileParityType[f] := FileOpenSetDefault( nParityType,            fileParityType[f], PARITY_NONE ) 
  fileDataBits[f]   := FileOpenSetDefault( nDataBits,              fileDataBits[f],   DATA_8 ) 
  fileStopBits[f]   := FileOpenSetDefault( nStopBits,              fileStopBits[f],   STOP_1 ) 

  ' Auto-limit to 19200 baud if necessary
       
  if CLKFREQ =< 96_000_000 
    fileBitTime[f] #>= txBitTimeAt19200Baud

  txInvert := ( nPinNumber => 28 ) ^ ( nBaudRate < 0 )
    
  TxPut( TX_CMD_OPEN | f, txInvert )

  if nMode == FILE_MODE_CONSOLE
    rxBitTime := fileBitTime[f]
    rxInvert  := txInvert
  
PRI FileOpenSetDefault( requested, current, default )

  if ( result := requested ) == 0
    if ( result := current ) == 0
      result := default
  
PRI FileCloseAll | f

  repeat f from 0 to FILE_MAX
    if fileMode[ f ] <> FILE_MODE_CONSOLE
      FileClose( f )
    
PRI FileClose( f )

  if fileMode[ f ] & FILE_MODE_OUTPUT
    TxPut( TX_CMD_CLOSE | f, 0 )
    repeat until TxEmpty
  fileMode[ f ] := FILE_MODE_CLOSED

PRI FileNumber

  result := PositiveNumber & FILE_MAX

PRI ListFiles( n ) | f, nRepeat

  n &= FILE_MODE_OPEN

  repeat f from 0 to FILE_MAX
    if ( fileMode[f] & FILE_MODE_OPEN ) & n
      if fileMode[f] == FILE_MODE_CONSOLE
        ListThisFile( f, RX_PIN, FILE_MODE_INPUT )
      ListThisFile( f, filePinNumber[f] , fileMode[f] )
      result++
      
  if result == 0
    Str( String( "None" ) )

PRI ListThisFile( f, nPin, nMode )

  Dec( f )
  Out( " " )
  if nMode & FILE_MODE_OUTPUT
    Out( ">" )
  else
    Out( "<" )
  Out( " " )
  Dec( nPin )
  Out( "," )
  Dec( CLKFREQ / fileBitTime[f] )
  Out( "," )
  Out( LookupZ( fileParityType[f] : "?NOE01" ) )
  Out( "," )
  Dec( fileDataBits[f] )
  Out( "," )
  Dec( fileStopBits[f] )
  if fileMode[f] == FILE_MODE_CONSOLE
    Str( String( " Console" ) )
  Out( $0D )
             
DAT
{

         88888888888 Y88b   d88P    888    888                        888 888                  
             888      Y88b d88P     888    888                        888 888                  
             888       Y88o88P      888    888                        888 888                  
             888        Y888P       8888888888  8888b.  88888b.   .d88888 888  .d88b.  888d888 
             888        d888b       888    888     "88b 888 "88b d88" 888 888 d8P  Y8b 888P"   
             888       d88888b      888    888 .d888888 888  888 888  888 888 88888888 888     
             888      d88P Y88b     888    888 888  888 888  888 Y88b 888 888 Y8b.     888     
             888     d88P   Y88b    888    888 "Y888888 888  888  "Y88888 888  "Y8888  888     
                                                                                               
}
CON

  TX_BUFFER_MASK = $3F

  TX_STACK_SIZE = 25

  PARITY_NONE   = 1
  PARITY_ODD    = 2
  PARITY_EVEN   = 3
  PARITY_ZERO   = 4
  PARITY_ONE    = 5
  
  DATA_7        = 7
  DATA_8        = 8

  STOP_1        = 1
  STOP_2        = 2

  TC_CMD_MASK   = %111_00000
  
  TX_CMD_TXBYTE = %000_00000
  TX_CMD_OPEN   = %001_00000
  TX_CMD_CLOSE  = %010_00000
  TX_CMD_LOW    = %011_00000
  TX_CMD_HIGH   = %100_00000
  TX_CMD_TOGGLE = %101_00000
  TX_CMD_BREAK  = %110_00000
  TX_CMD_PAUSE  = %111_00000
    
VAR

  byte txCogNumber
  
  byte txPutPtr
  byte txGetPtr
  byte txBuffer       [ TX_BUFFER_MASK+2 ]
  byte txFileNum      [ TX_BUFFER_MASK+2 ]
  
  long txStack        [ TX_STACK_SIZE ]

  long txBitTimeAt19200Baud
  
PRI TxVersion

  result := String( "TX" )
    
PRI TxInit

  if txCogNumber
    CogStop( txCogNumber~ - 1 )

  txGetPtr := txPutPtr

  txBitTimeAt19200Baud := CLKFREQ / 19200
     
  CogSetInfo( txCogNumber := CogNew( TxHandler, CogNewStack(@txStack,TX_STACK_SIZE) ) , TxVersion )
  txCogNumber++
  
PRI TxEmpty

  result := ( txPutPtr == txGetPtr )
  
PRI TxOut( n )

  TxPut( fileHandle, n )
  if n == $0D
    TxPut( fileHandle, $0A )

PRI TxPut( f, n ) | txNxtPtr

  txNxtPtr := ( txPutPtr+1 ) & TX_BUFFER_MASK
  repeat while txNxtPtr == txGetPtr
  txFileNum[ txPutPtr ] := f
  txBuffer[ txPutPtr ] := n
  txPutPtr := txNxtPtr
  
PRI TxHandler | f, n, txPin, timeout, txBitTime, txParityType, txDataBits, txStopBits

  repeat

    repeat while txGetPtr == txPutPtr

    case ( f := txFileNum[ txGetPtr ] ) & TC_CMD_MASK

      TX_CMD_TXBYTE :
       
        ' Get all the required data from the buffer ...
        
        txPin        := filePinNumber[f]
        txBitTime    := fileBitTime[f]
        txParityType := fileParityType[f]
        txDataBits   := fileDataBits[f]
        txStopBits   := fileStopBits[f]
        n            := txBuffer[ txGetPtr ]
       
        ' ... before allowing something else to overwrite it
        
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK
       
        ' Determine the data bits to send
        
        n := ( n ^ $FF ) & ( ( |< txDataBits ) - 1 )
       
        ' Add in any parity bits

        if txParityType <> PARITY_NONE
          txStopBits++
          case txParityType
            PARITY_ODD  : result := BitCount( n ) ^ 1
            PARITY_EVEN : result := BitCount( n )
            PARITY_ZERO :
            PARITY_ONE  : result := 1
            other       : txStopBits--
          if result & 1
            n |= |< txDataBits
           
        ' Set the start bit, invert bit stream as required, and pre-adjust for banging out
        
        n := ( ( n << 1 | 1 ) ^ ( OUTA[ txPin ] <> 0 ) ) << 1
       
        txDataBits += txStopBits + 2
       
        ' Bit-bang it out
        
        timeout := CNT
        repeat txDataBits
          OUTA[ txPin ] := ( n ~>= 1 )
          WaitCnt( timeout += txBitTime )

      TX_CMD_OPEN :

        f &= $1F
        txPin     := filePinNumber[ f ]
        txBitTime := fileBitTime[ f ]
        n         := txBuffer[ txGetPtr ] & 1

        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK
               
        result := ( ( OUTA[ txPin ] <> n ) or ( DIRA[ txPin ] <> 1 ) )

        OUTA[ txPin ] := n
        DIRA[ txPin ] := 1
        
        if result
          WaitCnt( ( txBitTime << 4 ) + CNT )

      TX_CMD_CLOSE :            ' CLOSE
        
        DIRA[ filePinNumber[ f & $7F ] ] := 0
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

      TX_CMD_LOW :              ' LOW

        OUTA[ filePinNumber[ f & $1F ] ] := 0
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

      TX_CMD_HIGH :             ' HIGH

        OUTA[ filePinNumber[ f & $1F ] ] := 1
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

      TX_CMD_TOGGLE :           ' TOGGLE

        OUTA[ filePinNumber[ f & $1F ] ] ^= 1
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

      TX_CMD_BREAK :            ' BREAK ( n x 1mS )

        txPin    := filePinNumber[ f & $1F ]
        n        := txBuffer[ txGetPtr ]
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

        OUTA[ txPin ] ^= 1
        if n
          WaitCnt( CLKFREQ / 1000 * n + CNT )
        OUTA[ txPin ] ^= 1
 
      TX_CMD_PAUSE :           ' PAUSE ( n x 1mS )

        n        := txBuffer[ txGetPtr ]
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

        if n
          WaitCnt( CLKFREQ / 1000 * n + CNT )

PRI BitCount( n )

  repeat while n <> 0
    result += ( n & 1 )
    n >>= 1
           
DAT
{

          8888888b.  Y88b   d88P    888    888                        888 888                  
          888   Y88b  Y88b d88P     888    888                        888 888                  
          888    888   Y88o88P      888    888                        888 888                  
          888   d88P    Y888P       8888888888  8888b.  88888b.   .d88888 888  .d88b.  888d888 
          8888888P"     d888b       888    888     "88b 888 "88b d88" 888 888 d8P  Y8b 888P"   
          888 T88b     d88888b      888    888 .d888888 888  888 888  888 888 88888888 888     
          888  T88b   d88P Y88b     888    888 888  888 888  888 Y88b 888 888 Y8b.     888     
          888   T88b d88P   Y88b    888    888 "Y888888 888  888  "Y88888 888  "Y8888  888     

}
CON

  RX_BUFFER_MASK = $3F

  RX_STACK_SIZE = 20
  
VAR

  byte rxPutPtr
  byte rxGetPtr
  byte rxBuffer       [ RX_BUFFER_MASK+2 ]
  
  long rxStack        [ RX_STACK_SIZE ]

  long rxBitTime
  byte rxInvert
  byte rxBreak

PRI RxVersion

  result := String( "RX" )
    
PRI RxInit

  CogSetInfo( CogNew( RxHandler, CogNewStack(@rxStack,RX_STACK_SIZE) ) , RxVersion )  

PRI RxAnyAvailable

  result := rxGetPtr <> rxPutPtr

PRI RxGetAny

  if rxGetPtr == rxPutPtr
    result := -1
  else
    result := RxGet

PRI RxGet

  repeat while rxGetPtr == rxPutPtr 
  result := rxBuffer[ rxGetPtr ]
  rxGetPtr := ( rxGetPtr + 1 ) & RX_BUFFER_MASK

PRI RxFlush

  repeat until RxGetAny < 0
  
PRI RxHandler | n, timeout, rxNxtPtr, rxStopBit

  DIRA[ RX_PIN ] := 0

  repeat

    if rxInvert
      WaitPeq( constant( |< RX_PIN ), constant( |< RX_PIN ), 0)
      WaitPne( constant( |< RX_PIN ), constant( |< RX_PIN ), 0)
      timeout := CNT + ( rxbitTime >> 1 )
    else
      WaitPne( constant( |< RX_PIN ), constant( |< RX_PIN ), 0)
      WaitPeq( constant( |< RX_PIN ), constant( |< RX_PIN ), 0)
      timeout := CNT + ( rxbitTime >> 1 )
    
    repeat 8
      WaitCnt( timeout += rxBitTime )
      n := ( n << 1 ) | INA[ RX_PIN]

    WaitCnt( timeout += rxBitTime )

    if ( n := ( n >< 8 ) ^ rxInvert ^ $FF ) == 0
      rxStopBit := INA[ RX_PIN] ^ rxInvert & 1
    else
      rxStopBit := false
      
    if rxStopBit
      rxBreak := true
    else
      rxNxtPtr := ( rxPutPtr+1 ) & RX_BUFFER_MASK
      repeat while rxNxtPtr == rxGetPtr
      rxBuffer[ rxPutPtr ] := n
      rxPutPtr := rxNxtPtr

DAT
{

          888    d8P  888888b.      888    888                        888 888                  
          888   d8P   888  "88b     888    888                        888 888                  
          888  d8P    888  .88P     888    888                        888 888                  
          888d88K     8888888K.     8888888888  8888b.  88888b.   .d88888 888  .d88b.  888d888 
          8888888b    888  "Y88b    888    888     "88b 888 "88b d88" 888 888 d8P  Y8b 888P"   
          888  Y88b   888    888    888    888 .d888888 888  888 888  888 888 88888888 888     
          888   Y88b  888   d88P    888    888 888  888 888  888 Y88b 888 888 Y8b.     888     
          888    Y88b 8888888P"     888    888 "Y888888 888  888  "Y88888 888  "Y8888  888     

}
VAR

  byte kbBreak

PRI KbInit

  CogNewStack( 0, 0 )
  CogSetInfo( kb.start( KB_DAT_PIN, KB_CLK_PIN ) - 1, kb.Version )

PRI KbAnyAvailable_DO_NOT_USE

  result := -1  '  @@@@@@@@@@@@@@@@@@@@@@@@@@@
  
PRI KbGetAny

  if ( result := kb.key ) == 0
    result := -1

PRI KbGet

  repeat Until ( result := kb.key ) <> 0

PRI KbFlush

  repeat while kb.key <> 0

DAT
{

           8888888 888b    888    888    888                        888 888                  
             888   8888b   888    888    888                        888 888                  
             888   88888b  888    888    888                        888 888                  
             888   888Y88b 888    8888888888  8888b.  88888b.   .d88888 888  .d88b.  888d888 
             888   888 Y88b888    888    888     "88b 888 "88b d88" 888 888 d8P  Y8b 888P"   
             888   888  Y88888    888    888 .d888888 888  888 888  888 888 88888888 888     
             888   888   Y8888    888    888 888  888 888  888 Y88b 888 888 Y8b.     888     
           8888888 888    Y888    888    888 "Y888888 888  888  "Y88888 888  "Y8888  888     

}

PRI InGetAny

  if ( result := RxGetAny ) < 0
    result := KbGetAny

DAT
{

         88888888888 888     888    888    888                        888 888                  
             888     888     888    888    888                        888 888                  
             888     888     888    888    888                        888 888                  
             888     Y88b   d88P    8888888888  8888b.  88888b.   .d88888 888  .d88b.  888d888 
             888      Y88b d88P     888    888     "88b 888 "88b d88" 888 888 d8P  Y8b 888P"   
             888       Y88o88P      888    888 .d888888 888  888 888  888 888 88888888 888     
             888        Y888P       888    888 888  888 888  888 Y88b 888 888 Y8b.     888     
             888         Y8P        888    888 "Y888888 888  888  "Y88888 888  "Y8888  888     

}

PRI TvMode( n )

  tv.Open( TV_PIN, n )

PRI TvCls

  tv.Cls
    
PRI TvAt( nRow, nColumn )

  tv.At( nRow, nColumn )

PRI TvAtRow( nRotoken )

  tv.AtRow( nRotoken )

PRI TvColor( n )

  tv.SetColour( n )

PRI TvGetCurrentRow

  result := tv.GetCurrentRow
  
PRI TvGetCurrentColumn

  result := tv.GetCurrentColumn
         
DAT
{

     .d8888b.                       88888888888                       888      d8b                   
    d88P  Y88b                          888                           888      Y8P                   
    888    888                          888                           888                            
    888         .d88b.   .d88b.         888  888d888 8888b.   .d8888b 888  888 888 88888b.   .d88b.  
    888        d88""88b d88P"88b        888  888P"      "88b d88P"    888 .88P 888 888 "88b d88P"88b 
    888    888 888  888 888  888        888  888    .d888888 888      888888K  888 888  888 888  888 
    Y88b  d88P Y88..88P Y88b 888        888  888    888  888 Y88b.    888 "88b 888 888  888 Y88b 888 
     "Y8888P"   "Y88P"   "Y88888        888  888    "Y888888  "Y8888P 888  888 888 888  888  "Y88888 
                             888                                                                 888 
                        Y8b d88P                                                            Y8b d88P 
                         "Y88P"                                                              "Y88P"  
}
  
VAR

  long cogLastStkPtr
  word cogLastStkSiz

  long cogInfoStkPtr[8]
  word cogInfoStkSiz[8]
  long cogInfoTxtPtr[8]
  
PRI CogNewStack( nStackPtr, nStackSize )

  cogLastStkPtr := result := nStackPtr

  if nStackSize
    cogLastStkSiz := nStackSize
    repeat nStackSize
      long[ nStackPtr ] := MAGIC_NUMBER
      nStackPtr += 4
  else
    cogLastStkSiz := nStackSize
    ' fill Main stack
    nStackPtr := nStackPtr + constant( 1000 << 2 ) & ! 3
    repeat while nStackPtr < codeBase
      ' long[ nStackPtr ] := MAGIC_NUMBER
      nStackPtr += 4

PRI CogSetInfo( nCogNumber, nCogTxtPtr )

  if ( result := nCogNumber ) => 0
    cogInfoStkPtr[ nCogNumber ] := cogLastStkPtr
    cogInfoStkSiz[ nCogNumber ] := cogLastStkSiz
    cogInfoTxtPtr[ nCogNumber ] := nCogTxtPtr

PRI CogStackUsed( nCogNumber ) | nPtr

  nPtr := cogInfoStkPtr[ nCogNumber ]
  repeat while long[ nPtr ] <>  MAGIC_NUMBER and result =< cogInfoStkSiz[ nCogNumber ]
    result++
    nPtr += 4
  
PRI ListCogs  | n

  repeat n from 0 to 7
    Dec( n )
    Out( " " )
    if cogInfoTxtPtr[n] 
      if cogInfoStkPtr[n] 
        Adr( cogInfoStkPtr[n] )
        Tab( 9 )
        if cogInfoStkSiz[n] 
          Dec( cogInfoStkSiz[n] )
          Tab(15) 
          Dec( cogStackUsed(n) )
        else
          Out( "-" )
          Tab( 14 )
          Out( "-" )
      else
        Str( String( "None" ) )
        Tab( 9 )
        Out( "-" )
        Tab( 14 )
        Out( "-" )
      Tab( 20 ) 
      Str( cogInfoTxtPtr[n] ) 
    else
      Str( String( "Free" ) )
    Out( $0D )
    
DAT
{

                   .d8888b.                888             8888888          d8b 888    
                  d88P  Y88b               888               888            Y8P 888    
                  888    888               888               888                888    
                  888         .d88b.   .d88888  .d88b.       888   88888b.  888 888888 
                  888        d88""88b d88" 888 d8P  Y8b      888   888 "88b 888 888    
                  888    888 888  888 888  888 88888888      888   888  888 888 888    
                  Y88b  d88P Y88..88P Y88b 888 Y8b.          888   888  888 888 Y88b.  
                   "Y8888P"   "Y88P"   "Y88888  "Y8888     8888888 888  888 888  "Y888 
                                                                                       
}
DAT
{

        Note that the code layout is quite different depending on whether there is any code or not. When
        flushed codeTop is below codeBot and what codeBot and codeTop point to is undefined. When there
        is code, codeBot points to the first token of program and codeTop points to the last used memory
        location which will always contain @tagEOF. It is done this way so that when a LIST MEM executes
        after a NEW the Free size will be an exact multiple of 1KB.
        
        codeTop ------>  
                        .---------.                     .---------.
        codeBot ------> |   ???   |    codeBot -------> | @tagNUM |  
                        `---------'                     |         |
                                                        :         :
                                                        |         |
                                                        |---------|
                                                        | @tagEOL |
                                                        |---------|
                                        codeTop ------> | @tagEOF |
                                                        `---------'
}
VAR

  long codeBase

PRI FlushCode

  if debug & DEBUG_INIT
    Dbg( String( "INI FlushCode",$0D ) )

  CondInit

  codeBot := codeBase
  codeTop := codeBot-1

  varsBot := codeTop+1
  varsTop := varsBot-1

  stakTop := $7FFF
  stakBot := stakTop+1

  heapTop := stakTop
  heapBot := stakBot

  byte[ codeBot ] := lookupAtTagEof
  
PRI ResetCode

  if debug & DEBUG_INIT
    Dbg( String( "INI ResetCode",$0D ) )

  CondInit

  ResetVars

  varsBot := codeTop+1
  varsTop := varsBot-1
  
  stakTop := $7FFF
  stakBot := stakTop+1

  heapTop := stakTop
  heapBot := stakBot

PRI ResetVars

  if debug & DEBUG_INIT
    Dbg( String( "INI ResetVars",$0D ) )

  if codeTop =< codeBot
    codeTop := codeBot-1
  else
    codeTop := codeBot - 1
    if byte[ codeBot ] <> lookupAtTagEOF
      fileHandle := -1
      codeTop++
      repeat while byte[ codeTop ] <> lookupAtTagEOF
        codeTop := ListLine( codeTop )
    fileHandle := 0


DAT
{

         888                            888                .d8888b.                             
         888                            888               d88P  Y88b                            
         888                            888               Y88b.                                 
         888      .d88b.   8888b.   .d88888      888       "Y888b.    8888b.  888  888  .d88b.  
         888     d88""88b     "88b d88" 888    8888888        "Y88b.     "88b 888  888 d8P  Y8b 
         888     888  888 .d888888 888  888      888            "888 .d888888 Y88  88P 88888888 
         888     Y88..88P 888  888 Y88b 888               Y88b  d88P 888  888  Y8bd8P  Y8b.     
         88888888 "Y88P"  "Y888888  "Y88888                "Y8888P"  "Y888888   Y88P    "Y8888  

}

PRI LoadCodeFromEeprom

  LoadOrVerifyCodeFromEeprom( false )
  
PRI LoadOrVerifyCodeFromEeprom( isVerifying ) | n, nSize, nBlockSize, nCount

  if debug & DEBUG_INIT
    if isVerifying
      Dbg( String( "INI Verify" ) )
    else
      Dbg( String( "INI Load" ) )
  
  if IsAnythingSavedToEeprom
  
    FlushCode

    codeBot := i2c.ReadLong( @codeBot )
    codeTop := i2c.ReadLong( @codeTop )

    nBlockSize := BlockSize( nSize := codeTop-CodeBot )
    n := codeBot
    nCount := 0
    repeat
      Out( "*" )
      i2c.ReadByteArray( n, n, nBlockSize )
      n      += nBlockSize
      nCount += nBlockSize
    until n => codeTop

    OnNewLine

    if IsCodeLoadedSameAsCodeSaved
      if isVerifying
        Str( String( "Verified" ) )
      else
        Str( String( "Loaded" ) )
    else
      Str( String( "Failed" ) )
      FlushCode

  else
    Str( String( "None Saved" ) )
  
PRI SaveCodeToEeprom | n, nSize, nBlockSize, nCount

  if debug & DEBUG_INIT
    Dbg( String( "INI Save" ) )

  ResetCode
  If codeBot > codeTop
    Str( String( "No code" ) )
  else

    nBlockSize := BlockSize( nSize := codeTop-CodeBot )
    n := codeBot
    nCount := 0
    repeat
      Out( "*" )
      i2c.WriteByteArray( n, n, nBlockSize )
      n      += nBlockSize
      nCount += nBlockSize
    until n => codeTop

    SetCodeSavedToEeprom

    OnNewLine
    Str( String( "Saved",$0D ) )
    
    LoadOrVerifyCodefromEeprom( true )

PRI BlockSize( n )

  n /= 32
  result := 1
  repeat while result =< n
    result <<= 1

DAT
{

         .d8888b.  888                        888                                               
        d88P  Y88b 888                        888                                               
        888    888 888                        888                                               
        888        88888b.   .d88b.   .d8888b 888  888 .d8888b  888  888 88888b.d88b.  .d8888b  
        888        888 "88b d8P  Y8b d88P"    888 .88P 88K      888  888 888 "888 "88b 88K      
        888    888 888  888 88888888 888      888888K  "Y8888b. 888  888 888  888  888 "Y8888b. 
        Y88b  d88P 888  888 Y8b.     Y88b.    888 "88b      X88 Y88b 888 888  888  888      X88 
         "Y8888P"  888  888  "Y8888   "Y8888P 888  888  88888P'  "Y88888 888  888  888  88888P' 

                                                                                                
}
VAR

  long checksumLookup
  long checknotLookup
  
  long checksumVersion
  long checknotVersion

  long checksumCode
  long checknotCode

PRI IsAnythingSavedToEeprom

  result := ( i2c.ReadLong( @checksumLookup  ) == checksumLookup  ) and {
}           ( i2c.ReadLong( @checknotLookup  ) == checknotLookup  ) and {
}           ( i2c.ReadLong( @checksumVersion ) == checksumVersion ) and {
}           ( i2c.ReadLong( @checknotVersion ) == checknotVersion )

PRI SetCodeSavedToEeprom

  checknotCode := ! ( checksumCode := CalculateCodeChecksum )
  
  i2c.WriteLong( @codeBot         , codeBot         )
  i2c.WriteLong( @codeTop         , codeTop         )
    
  i2c.WriteLong( @checksumCode    , checksumCode    )
  i2c.WriteLong( @checknotCode    , checknotCode    )

  i2c.WriteLong( @checksumLookup  , checksumLookup  )
  i2c.WriteLong( @checknotLookup  , checknotLookup  ) 

  i2c.WriteLong( @checksumVersion , checksumVersion ) 
  i2c.WriteLong( @checknotVersion , checknotVersion )

PRI IsCodeLoadedSameAsCodeSaved

  checknotCode := ! ( checksumCode := CalculateCodeChecksum )

  result := ( IsAnythingSavedToEeprom                          ) and {
}           ( i2c.ReadLong( @codeBot        ) == codeBot       ) and {
}           ( i2c.ReadLong( @codeTop        ) == codeTop       ) and {
}           ( i2c.ReadLong( @checksumCode   ) == checksumCode  ) and {
}           ( i2c.ReadLong( @checknotCode   ) == checknotCode  ) 
  
PRI CalculateCodeChecksum | n

  ResetCode
  result := checksumLookup + MAGIC_NUMBER
  if codeTop => codeBot
    repeat n from codeBot to codeTop
       result += byte[ n ]

DAT
{                                                                                       

       .d8888b.                888             888      d8b          888    d8b                   
      d88P  Y88b               888             888      Y8P          888    Y8P                   
      888    888               888             888                   888                          
      888         .d88b.   .d88888  .d88b.     888      888 .d8888b  888888 888 88888b.   .d88b.  
      888        d88""88b d88" 888 d8P  Y8b    888      888 88K      888    888 888 "88b d88P"88b 
      888    888 888  888 888  888 88888888    888      888 "Y8888b. 888    888 888  888 888  888 
      Y88b  d88P Y88..88P Y88b 888 Y8b.        888      888      X88 Y88b.  888 888  888 Y88b 888 
       "Y8888P"   "Y88P"   "Y88888  "Y8888     88888888 888  88888P'  "Y888 888 888  888  "Y88888 
                                                                                              888 
                                                                                         Y8b d88P 
                                                                                          "Y88P"  
}
VAR

  long listFrom
  word listCount

  byte listNeedSpace

PRI ListCode

  ListLines( 0, 0 )
    
PRI ListLines( n, nCount )

  if codeTop =< codeBot
    Str( @aboNO_CODE )
    Out( $0D )
  else

    if ( listFrom := n ) == 0
      listFrom := codeBot
     
    listCount := nCount
    repeat
      listFrom := ListLine(listFrom)
    until byte[ listFrom ] == lookupAtTagEOF or --nCount == 0
     
    if byte[ listFrom ] == lookupAtTagEOF
      listFrom := 0
      
PRI ListLine( n )

  listNeedSpace := false
  numberRadix := 10
  repeat while ( result := opcLookupTable[ byte[ n++ ] ] ) <> @tagEOL
    n := ListToken( n, result )
  Out( $0D )
  result := n

PRI ListToken( n, thisToken )

  if listNeedSpace~~
    Out( " " )
  case thisToken
    @tagBYTE, @tagWORD, @tagTRIP, @tagLONG :
      ' Needs -thisToken so 'token' variable isn't splatted 
      n := GetTokenNumber( n, -thisToken )
      OutNumberFormat( getTokenNumberValue , numberRadix, 0 )
    @tagVAR, @tagNEW:
      if fileHandle == -1
        byte[ n-1 ] := lookupAtTagNEW
        n := SetTokenCachedValue( n, 0 )
      else
        n := SkipTokenCachedValue( n )
      repeat
        Out( ( result := byte[ n++ ] ) & $7F )
      while ( result & $80 )
    @tagREG :
      StrChoice( @reg_LIST_START, byte[ n++ ] & $F )
    @tagTXT:
      Out( $22 )
      repeat
        if ( result := byte[ n++ ] ) & $7F
          ListTextChar( result & $7F )
      while ( result & $80 )
      Out( $22 )
    @tagREM :
      Out( "'" )
      repeat
        if ( result := byte[ n++ ] ) & $7F
          Out( result & $7F )
      while ( result & $80 )
    @tagBIN :
      numberRadix := 2
      Out( "%" )
      listNeedSpace := false 
    @tagHEX :
      numberRadix := 16
      Out( "$" )
      listNeedSpace := false
    @tagQUD :
      numberRadix := 4
      Out( "%" )
      Out( "%" )
      listNeedSpace := false
    @opcGOTO, @opcGOSUB :
      if fileHandle == -1
        n := SetTokenCachedValue( n, 0 )
      else
        n := SkipTokenCachedValue( n )
      Str( thisToken )
    other :
      Str( thisToken )

  result := n

PRI ListTextChar( n )

  if n == $22
    Out( $22 )
  Out( n )

PRI SkipLine( nPc )

   fileHandle := -2   
   result := ListLine( nPc )
   fileHandle := 0

DAT
{

               .d8888b.                888             888     888 888    d8b 888          
              d88P  Y88b               888             888     888 888    Y8P 888          
              888    888               888             888     888 888        888          
              888         .d88b.   .d88888  .d88b.     888     888 888888 888 888 .d8888b  
              888        d88""88b d88" 888 d8P  Y8b    888     888 888    888 888 88K      
              888    888 888  888 888  888 88888888    888     888 888    888 888 "Y8888b. 
              Y88b  d88P Y88..88P Y88b 888 Y8b.        Y88b. .d88P Y88b.  888 888      X88 
               "Y8888P"   "Y88P"   "Y88888  "Y8888      "Y88888P"   "Y888 888 888  88888P' 
                                                                                           
}
VAR

  long codeBot
  long codeTop

PRI PushOpc( n )

  if pc == 0
    pc := codeBot
    
  byte[ pc++ ] := GetFromOpcLookupTable( n )
  if n == @opcGOTO or n == @opcGOSUB
    if IsPropellerMkII
      byte[ pc++ ] := 0
    byte[ pc++ ] := 0
    byte[ pc++ ] := 0
  
PRI PushVar( strPtr )

  PushOpc( @tagNEW )    
  if IsPropellerMkII
    byte[ pc++ ] := 0
  byte[ pc++ ] := 0
  byte[ pc++ ] := 0
  repeat StrSize( strPtr ) - 1
    byte[ pc++ ] := byte[ strPtr++ ] | $80
  byte[ pc++ ] := byte[ strPtr ]
    
PRI PushNum( n )

  if n & $FF00_0000
    PushOpc( @tagLONG )
    byte[ pc++ ] := n >> 24
    byte[ pc++ ] := n >> 16
    byte[ pc++ ] := n >> 8
    byte[ pc++ ] := n
  else
    if n & $FFFF_0000
      PushOpc( @tagTRIP )
      byte[ pc++ ] := n >> 16
      byte[ pc++ ] := n >> 8
      byte[ pc++ ] := n
    else
      if n & $FFFF_FF00
        PushOpc( @tagWORD )
        byte[ pc++ ] := n >> 8
        byte[ pc++ ] := n
      else
        PushOpc( @tagBYTE )
        byte[ pc++ ] := n

PRI PushTxt( strPtr )

  PushOpc( @tagTXT )
  if strPtr <> 0 and StrSize( strPtr )
    repeat StrSize( strPtr ) - 1
      byte[ pc++ ] := byte[ strPtr++ ] | $80
    byte[ pc++ ] := byte[ strPtr ]
  else
    byte[ pc++ ] := 0

PRI PushReg( n )

  PushOpc( @tagREG )
  byte[ pc ++ ] := n
  
DAT
{

 888      d8b                                                      888     888 888    d8b 888          
 888      Y8P                                                      888     888 888    Y8P 888          
 888                                                               888     888 888        888          
 888      888 88888b.   .d88b.  88888b.  888  888 88888b.d88b.     888     888 888888 888 888 .d8888b  
 888      888 888 "88b d8P  Y8b 888 "88b 888  888 888 "888 "88b    888     888 888    888 888 88K      
 888      888 888  888 88888888 888  888 888  888 888  888  888    888     888 888    888 888 "Y8888b. 
 888      888 888  888 Y8b.     888  888 Y88b 888 888  888  888    Y88b. .d88P Y88b.  888 888      X88 
 88888888 888 888  888  "Y8888  888  888  "Y88888 888  888  888     "Y88888P"   "Y888 888 888  88888P' 
                                                                         
}
DAT

'       For GOTO and GOSUB the address of the line to go to is cached, or needs to be determined
'       and then cached ...

'                       .----------.
'       lastPc -------> | @opcGOTO |
'                       |----------|
'                       |          | \
'                       :          :  |  }-- value = Address of line to go to
'                       |          | /
'                       |----------|
'                       | @opcLONG |
'                       |----------|
'                       |          |
'                       :          :
'                       |          |
'                       `----------'
'
'       Note that for "GOTO @ var", although the cached address bytes are still included after the
'       @opcGOTO or @opcGOSUB byte they are never used, and the value held in the variable at the time
'       is used as destination address ...
'
'                       .----------.
'       lastPc -------> | @opcGOTO |
'                       |----------|
'                       |          | 
'                       :   Zero   :
'                       |          | 
'                       |----------|
'                       | @opcAt   |
'                       |----------|
'                       | @tagVAR  |
'                       |----------|
'                       |          |
'                       :          :
'                       |          |
'                       `----------'
' 
'       For all other cases the address of the line refered to needs always to be determined,and
'       there is no caching ...

'                       .----------.
'       lastPc -------> | @opcLIST |
'                       |----------|
'                       | @opcLONG |
'                       |----------|
'                       |          |
'                       :          :
'                       |          |
'                       `----------'

PRI PreCachedLineNumber | nV, nLastPc

  nV := value
  nLastPc := lastPc
  GetToken
  result := LineNumberPc( nV, nLastPc )
  
PRI LineNumber

  result := LineNumberPc( 0, 0 )
  
PRI LineNumberPc( cached, nPc )

' if GOTO * / GOSUB * then a variable is assumed t hold the address of the line to goto

  result := cached ' Remember any pre-cached value

  if token == @symMPY
    GetToken
    VarRef
    result := varValue
  else
    if cached
      ExprLineNumber
    else
      if ( result := FindLineNumberPc( ExprLineNumber  ) ) =< 0
        Abort @aboINVALID_LINENUMBER
      if nPc
        SetTokenCachedValue( nPc+1, result )

PRI ExprLineNumber

  result := ConstantNumber
  if ( result =< 0 ) or ( result > 99999 )
    Abort @AboINVALID_LINENUMBER

PRI FindLineNumberPc( nLineNumber ) | nPc, nToken

  nPc := codeBot
  repeat

    case nToken := opcLookupTable[ byte[ nPc ] ]
    
      @tagBYTE, @tagWORD, @tagTRIP, @tagLONG :
      
        ' -nToken to prevent 'token' variable getting splatted
        GetTokenNumber( nPc+1, -nToken )
        if getTokenNumberValue => nLineNumber
          if getTokenNumberValue == nLineNumber
            return nPc
          else
            return -nPc
            
      @tagEOF :
        return -nPc

   nPc := SkipLine( nPc )
  
DAT
{

           .d8888b.  888                      888         888     888 888    d8b 888          
          d88P  Y88b 888                      888         888     888 888    Y8P 888          
          Y88b.      888                      888         888     888 888        888          
           "Y888b.   888888  8888b.   .d8888b 888  888    888     888 888888 888 888 .d8888b  
              "Y88b. 888        "88b d88P"    888 .88P    888     888 888    888 888 88K      
                "888 888    .d888888 888      888888K     888     888 888    888 888 "Y8888b. 
          Y88b  d88P Y88b.  888  888 Y88b.    888 "88b    Y88b. .d88P Y88b.  888 888      X88 
           "Y8888P"   "Y888 "Y888888  "Y8888P 888  888     "Y88888P"   "Y888 888 888  88888P' 
                                                                                              
}

VAR

  long stakBot
  long stakTop
  long holeMrk
  
PRI PushByte( n )

  byte[ --stakBot ] := n

PRI PushWord( n )

  PushByte( n )
  PushByte( n >> 8)

PRI PushLong( n )

  PushWord( n )
  PushWord( n >> 16 )

PRI PopByte

  result := byte[ stakBot++ ]

PRI PopWord

  result := PopByte << 8 | PopByte

PRI PopLong

  result := PopWord << 16 | PopWord
  
DAT
{

              888    888                               888     888 888    d8b 888          
              888    888                               888     888 888    Y8P 888          
              888    888                               888     888 888        888          
              8888888888  .d88b.   8888b.  88888b.     888     888 888888 888 888 .d8888b  
              888    888 d8P  Y8b     "88b 888 "88b    888     888 888    888 888 88K      
              888    888 88888888 .d888888 888  888    888     888 888    888 888 "Y8888b. 
              888    888 Y8b.     888  888 888 d88P    Y88b. .d88P Y88b.  888 888      X88 
              888    888  "Y8888  "Y888888 88888P"      "Y88888P"   "Y888 888 888  88888P' 
                                           888                                             
                                           888                                             
                                           888                                             

}
VAR

  long heapBot
  long heapTop

DAT
{

 888b     d888                                                     888     888 888    d8b 888          
 8888b   d8888                                                     888     888 888    Y8P 888          
 88888b.d88888                                                     888     888 888        888          
 888Y88888P888  .d88b.  88888b.d88b.   .d88b.  888d888 888  888    888     888 888888 888 888 .d8888b  
 888 Y888P 888 d8P  Y8b 888 "888 "88b d88""88b 888P"   888  888    888     888 888    888 888 88K      
 888  Y8P  888 88888888 888  888  888 888  888 888     888  888    888     888 888    888 888 "Y8888b. 
 888   "   888 Y8b.     888  888  888 Y88..88P 888     Y88b 888    Y88b. .d88P Y88b.  888 888      X88 
 888       888  "Y8888  888  888  888  "Y88P"  888      "Y88888     "Y88888P"   "Y888 888 888  88888P' 
                                                            888                                        
                                                       Y8b d88P                                        
                                                        "Y88P"                                         

}
CON
{

                .-----------.
        0000    |           |
                |           |   Main Interpreter ( Spin )
                |           |
                |-----.-----|
                |     |     |
                |    \|/    |   Interpreter Stack ( Spin )
                |           |
                | - - - - - |
                |           |   Hole
                |-----^-----|
                |           |
                |           |   User Code
                |           |
                |-----.-----|
                |     |     |
                |    \|/    |   User Variables
                |           |
                | - - - - - |
                |           |   Free
                | - - - - - |
                |           |
                |    /|\    |   User Stack
                |     |     |
                | - - - - - |
                |           |
                |    /|\    |   User Heap ( may not exist )
        7FFF    |     |     |
                `-----^-----'

}
CON

    MEM_BASE    = 0 << 2
    MEM_HOLE    = 1 << 2
    MEM_CODE    = 2 << 2
    MEM_VARS    = 3 << 2
    MEM_FREE    = 4 << 2
    MEM_STAK    = 5 << 2
    MEM_HEAP    = 6 << 2
    
    MEM_TXT     = 0
    MEM_BOT     = 1
    MEM_TOP     = 2
    MEM_USE     = 3

PRI ListMemory( showAll ) | n

  repeat n from MEM_BASE to MEM_HEAP step 4
    if MemInfo( n | MEM_USE ) or showAll
      Str( MemInfo( n | MEM_TXT ) )
      Str( String( "  " ) )
      Adr( MemInfo( n | MEM_BOT ) )
      Str( String( " .. " ) )
      Adr( MemInfo( n | MEM_TOP ) )             
      Str( String( "  " ) )
      Dkb( MemInfo( n | MEM_USE ) )
      if n == MEM_BASE
        Str( String( " ( " ) )
        Adr( @result )
        Str( String( " )" ) )
      Out( $0D )
    
PRI MemInfo( n )

  if @result > holeMrk
    holeMrk := @result

  case n
  
    MEM_BASE | MEM_TXT : result := String( "Base" )
    MEM_BASE | MEM_BOT : result := 0
    MEM_BASE | MEM_TOP : result := holeMrk | 1023

    MEM_HOLE | MEM_TXT : result := String( "Hole" )
    MEM_HOLE | MEM_BOT : result := ( holeMrk | 1023 ) + 1
    MEM_HOLE | MEM_TOP : result := codeBot - 1

    MEM_CODE | MEM_TXT : result := String( "Code" )
    MEM_CODE | MEM_BOT : result := codeBot
    MEM_CODE | MEM_TOP : result := codeTop

    MEM_VARS | MEM_TXT : result := String( "Vars" )
    MEM_VARS | MEM_BOT : result := varsBot
    MEM_VARS | MEM_TOP : result := varsTop

    MEM_FREE | MEM_TXT : result := String( "Free" )
    MEM_FREE | MEM_BOT : result := varsTop + 1
    MEM_FREE | MEM_TOP : result := stakBot - 1

    MEM_STAK | MEM_TXT : result := String( "Stak" )
    MEM_STAK | MEM_BOT : result := stakBot
    MEM_STAK | MEM_TOP : result := stakTop    

    MEM_HEAP | MEM_TXT : result := String( "Heap" )
    MEM_HEAP | MEM_BOT : result := HeapBot
    MEM_HEAP | MEM_TOP : result := HeapTop
    
    other              : n &= %111_00
                         result := MemInfo( n+2 ) - MemInfo( n+1 ) + 1
          
DAT
{

                   888     888                    888     888 888    d8b 888          
                   888     888                    888     888 888    Y8P 888          
                   888     888                    888     888 888        888          
                   Y88b   d88P 8888b.  888d888    888     888 888888 888 888 .d8888b  
                    Y88b d88P     "88b 888P"      888     888 888    888 888 88K      
                     Y88o88P  .d888888 888        888     888 888    888 888 "Y8888b. 
                      Y888P   888  888 888        Y88b. .d88P Y88b.  888 888      X88 
                       Y8P    "Y888888 888         "Y88888P"   "Y888 888 888  88888P' 
                                                                                      
}
CON

  #0
        VAR_VARADR              ' Where the var definition is in memory
        VAR_VALADR              ' Where the variables's values are held
        VAR_NAMADR              ' Where the variabe's name is
        VAR_NXTADR              ' Where the enxt variable is
  VAR_NAMLEN                    ' How many bytes in the name
  VAR_VARSIZ                    ' Fundamental size of the variable - 1, 2 or 4
        VAR_BYTSIZ              ' How many bytes of value are there
        VAR_VCOUNT              ' How many variables
        VAR_IDXMAX              ' Maximum Index allowed
        VAR_VARVAL              ' What the variable's value is ( or var(0)'s value )

VAR

  byte tmpVarSpace[16] ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  
VAR

  long varsBot
  long varsTop

PRI VarFunc( n1, n )

  result := VarInfo( 0, n ) ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  
PRI VarInfo( nPtr, n )

  case n
    VAR_VARADR : result := nPtr
    VAR_VALADR : result := nPtr + 2
    VAR_NAMADR : result := nPtr + 2 + VarInfo( nPtr, VAR_BYTSIZ )
    VAR_NXTADR : result := nPtr + 2 + VarInfo( nPtr, VAR_BYTSIZ ) + VarInfo( nPtr, VAR_NAMLEN )
    VAR_BYTSIZ : result := byte [ nPtr ] << 8 | byte[ nPtr+1 ]
    VAR_VCOUNT : result := ( VarInfo( nPtr, VAR_BYTSIZ ) / VarInfo( nPtr, VAR_VARSIZ ) )
    VAR_IDXMAX : result := VarInfo( nPtr, VAR_VCOUNT ) - 1
    VAR_VARVAL : result := PeekVar( nPtr + 2, VarInfo( nPtr, VAR_VARSIZ ) )
'    VAR_NAMLEN :           ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ 
'    VAR_VARSIZ :           ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
'                 result := GetVarSizeFromType( .... ) 
    other      : Abort @aboINVALID_VALUE

PRI GetVarSizeFromType( n )

  case n & $7F
    "%"   : result := 1
    "&"   : result := 2
    "$"   : result := 2 + ( IsPropellerMkII & 2 )
    other : result := 4

PRI CreateVar( nVarSize )

  if token == @tagNEW

    result := @tmpVarSpace + 4  ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    byte[ lastPc ] := lookupAtTagVAR
    {
    if ( result := FindOldVar( lastPc + 3 + ( IsPropellerMkII & 1 ) ) ) == 0 
      result := AddNewVar( nVarSize, lastPc + 3 + ( IsPropellerMkII & 1 ) ) 
    }
    SetTokenCachedValue( lastPc+1, result )

  else                                        
    result := value

PRI FindOldVar( nPtr ) | nVarPtr
  {
  if varsTop > varsBot
    nVarPtr := varsBot
    repeat while nVarPtr < varsTop
      nVarPtr := MatchThisVar( nPtr, nVarPtr )
      if nVarPtr =< 0
        return || nVarPtr
  }
  
PRI MatchThisVar( nPtr, nVarPtr )

 ' @@@@@@@@@

 
PRI AddNewVar( nSize, nPtr )
    
  result := varsTop := SetTokenCachedValue( ++varsTop, nSize )
  
  repeat nSize
    byte[ varsTop++ ] := 0

  repeat while ( byte[ varsTop++ ] := byte[ nPtr++ ] ) & $80

  varsTop--

PRI ListVars | nPtr, nSize

  if varsTop < varsBot
    Str( String( "None" ) )
  else
    nPtr := varsBot
    repeat while nPtr < varsTop
      nPtr := ListThisVar( nPtr )

PRI ListThisVar( nPtr ) | n, nVarType, nVarSize

  Adr( nPtr )
  Out( " " )

  nPtr := GetTokenCachedValue( nPtr )

  Dec( value )

  Tab( 11 )
  repeat n from 0 to ( value-1 ) <# 4
    Hex( byte[ nPtr+n ], 2 )
    Out( " " )
        
  nPtr += value

  n := nPtr
  repeat 
    nVarType := byte[ n++ ]
  while nVarType & $80

  nVarSize := GetVarSizeFromType( nVarType & $7F )

  Tab( 27 )
  repeat 
    Out( ( n := byte[ nPtr++ ] ) & $7F )
  while n & $80

  if nVarSize < value
    Out( "[" )
    Dec( value / nVarSize )
    Out( "]" )
    
  Out( $0D )

  return nPtr
  
DAT
{

    8888888888                                                   888     888 888    d8b 888          
    888                                                          888     888 888    Y8P 888          
    888                                                          888     888 888        888          
    8888888    .d88b.  88888b.  888d888 .d88b.  88888b.d88b.     888     888 888888 888 888 .d8888b  
    888       d8P  Y8b 888 "88b 888P"  d88""88b 888 "888 "88b    888     888 888    888 888 88K      
    888       88888888 888  888 888    888  888 888  888  888    888     888 888    888 888 "Y8888b. 
    888       Y8b.     888 d88P 888    Y88..88P 888  888  888    Y88b. .d88P Y88b.  888 888      X88 
    8888888888 "Y8888  88888P"  888     "Y88P"  888  888  888     "Y88888P"   "Y888 888 888  88888P' 
                       888                                                                           
                       888                                                                           
                       888                                                                           

}
VAR

  byte eepromCount
  
PRI CountEeproms | n

  if eepromCount == 0                                   ' Don't know how many Eeproms
    EepromOpen( 2 )                                     ' Open the second Eeprom which may not be there
    n := ! i2c.ReadLong( 0 )                            ' Read inverted data from address 0
    i2c.WriteLong( 0 , n )                              ' And put that back
    if ( result := ( n == i2c.ReadLong( 0 ) ) )         ' Flag if we can read what we wrote
      i2c.WriteLong( 0 , ! n )                          ' Restore original byte in address 0
    EepromClose                                         ' And we've finished with the second bank
    EepromOpen( eepromCount := 1 )                      ' Now, in the first bank
    if result
      eepromCount := 2                                  ' Indicate there are two Eeproms
    i2c.WriteByte( @eepromCount, eepromCount )    

PRI EepromOpen( bank ) ' bank = 1..N ( 0 == 1 )

  i2c.Open( I2C_SCL_PIN, I2C_SDA_PIN, i2c#EEPROM_24LC256, bank )

PRI EepromClose

  i2c.Close

PRI ListEeprom

  CountEeproms
  Dec( eepromCount )
  Out( $0D )
    
DAT
{

             8888888b.           888                                 d8b                   
             888  "Y88b          888                                 Y8P                   
             888    888          888                                                       
             888    888  .d88b.  88888b.  888  888  .d88b.   .d88b.  888 88888b.   .d88b.  
             888    888 d8P  Y8b 888 "88b 888  888 d88P"88b d88P"88b 888 888 "88b d88P"88b 
             888    888 88888888 888  888 888  888 888  888 888  888 888 888  888 888  888 
             888  .d88P Y8b.     888 d88P Y88b 888 Y88b 888 Y88b 888 888 888  888 Y88b 888 
             8888888P"   "Y8888  88888P"   "Y88888  "Y88888  "Y88888 888 888  888  "Y88888 
                                                        888      888                   888 
                                                   Y8b d88P Y8b d88P              Y8b d88P 
                                                    "Y88P"   "Y88P"                "Y88P"  

}
CON

  DEBUG_SHOWEXPR                = |< 0
  DEBUG_SHOWLINE                = |< 1
  DEBUG_SHOWTOKEN               = |< 2
  DEBUG_ALLTOKENS               = |< 3
  DEBUG_SHOWVARDEF              = |< 4
  DEBUG_GAVELNUM                = |< 5
  DEBUG_INIT                    = |< 6
  DEBUG_PARSE                   = |< 7
  
VAR                   

  long debug

PRI Dbg( strPtr )

  OnNewLine
  Out( "#" )
  Str( strPtr )
  if notHadCrLf
    Out( " " )
       
DAT
{

          88888888888       888                           888     888 888    d8b 888          
              888           888                           888     888 888    Y8P 888          
              888           888                           888     888 888        888          
              888   .d88b.  888  888  .d88b.  88888b.     888     888 888888 888 888 .d8888b  
              888  d88""88b 888 .88P d8P  Y8b 888 "88b    888     888 888    888 888 88K      
              888  888  888 888888K  88888888 888  888    888     888 888    888 888 "Y8888b. 
              888  Y88..88P 888 "88b Y8b.     888  888    Y88b. .d88P Y88b.  888 888      X88 
              888   "Y88P"  888  888  "Y8888  888  888     "Y88888P"   "Y888 888 888  88888P' 

}

CON

  MAX_OPCODES = 220
  
VAR

  long opcLookupTable[ MAX_OPCODES ]

  byte lookupAtTagEOF
  byte lookupAtTagNEW
  byte lookupAtTagVAR

PRI BuildOpcLookupTable | n
  
  checksumLookup := 0
  n := @opc_LIST_START
  repeat while n < @tag_LIST_END
    if byte[ n ]
      if result => MAX_OPCODES
        Str( String("Too many opcodes") )
        repeat
      checksumLookup <-= 3
      opcLookupTable[ result++ ] := n
      repeat while byte[ n ]
        checksumLookup += byte[ n++ ]
    n++
      
  lookupAtTagEOF := GetFromOpcLookupTable( @tagEOF )
  lookupAtTagNEW := GetFromOpcLookupTable( @tagNEW )
  lookupAtTagVAR := GetFromOpcLookupTable( @tagVAR )

  checksumVersion := checksumLookup <- 5
  n := Version
  repeat StrSize( n )
    checksumVersion -= byte[ n++ ]

  checknotLookup  := ! checksumLookup
  checknotVersion := ! checksumVersion
    
PRI GetFromOpcLookupTable( n )

  repeat while opcLookupTable[ result ] <> n
    result++
    
DAT
{

  88888888888       888                           888b    888                                          
      888           888                           8888b   888                                          
      888           888                           88888b  888                                          
      888   .d88b.  888  888  .d88b.  88888b.     888Y88b 888  8888b.  88888b.d88b.   .d88b.  .d8888b  
      888  d88""88b 888 .88P d8P  Y8b 888 "88b    888 Y88b888     "88b 888 "888 "88b d8P  Y8b 88K      
      888  888  888 888888K  88888888 888  888    888  Y88888 .d888888 888  888  888 88888888 "Y8888b. 
      888  Y88..88P 888 "88b Y8b.     888  888    888   Y8888 888  888 888  888  888 Y8b.          X88 
      888   "Y88P"  888  888  "Y8888  888  888    888    Y888 "Y888888 888  888  888  "Y8888   88888P' 

}
DAT
DAT

opc_LIST_START

opcBREAK                byte    "Break",0
'opcCALL                 byte    "Call",0
'opcCASE                 byte    "Case",0
opcCLOSE                byte    "Close",0
opcCLS                  byte    "Cls",0
opcCOGS                 byte    "Cogs",0
opcCOLOR                byte    "Color",0
opcDATA                 byte    "Data",0
opcDEBUG                byte    "Debug",0
'opcDEF                  byte    "Def",0
opcDIM                  byte    "Dim",0
'opcDIR                  byte    "Dir",0
'opcEDIT                 byte    "Edit",0
opcEND                  byte    "End",0
'opcERROR                byte    "Error",0
'opcEXIT                 byte    "Exit",0
opcFOR                  byte    "For",0
'opcFUNCTION             byte    "Function",0
opcGOSUB                byte    "Gosub",0
opcGOTO                 byte    "Goto",0
opcHIGH                 byte    "High",0              
opcIF                   byte    "If",0
opcINPUT                byte    "Input",0
'opcKILL                 byte    "Kill",0
opcLET                  byte    "Let",0
opcLIST                 byte    "List",0
opcLOAD                 byte    "Load",0
opcLOCATE               byte    "Locate",0
opcLOW                  byte    "Low",0
opcMEM                  byte    "Mem",0
'opcMODE                 byte    "Mode",0
'opcNAME                 byte    "Name",0
opcNEW                  byte    "New",0
'opcON                   byte    "On",0
opcOPEN                 byte    "Open",0
opcPAUSE                byte    "Pause",0
'opcPOP                  byte    "Pop",0
opcPRINT                byte    "Print",0
'opcPUSH                 byte    "Push",0
'opcQUIT                 byte    "Quit",0
opcREAD                 byte    "Read",0
'opcREBOOT               byte    "Reboot",0
opcREM                  byte    "Rem",0
'opcRENUM                byte    "Renum",0
opcREPEAT               byte    "Repeat",0
'opcRESET                byte    "Reset",0
opcRESTORE              byte    "Restore",0
opcRETURN               byte    "Return",0
opcRUN                  byte    "Run",0
opcSAVE                 byte    "Save",0
'opcSEEK                 byte    "Seek",0
'opcSELECT               byte    "Select",0
'opcSHELL                byte    "Shell",0
'opcSTART                byte    "Start",0
'opcSTEP                 byte    "Step",0
'opcSTOP                 byte    "Stop",0
'opcSUB                  byte    "Sub",0
'opcSYSTEM               byte    "System",0
'opcTAB                  byte    "Tab",0
'opcTO                   byte    "To",0
opcTOGGLE               byte    "Toggle",0
opcTV                   byte    "TV",0
opcVARS                 byte    "Vars",0
opcWAITCNT              byte    "WaitCnt",0
opcWAITPEQ              byte    "WaitPeq",0
opcWAITPNE              byte    "WaitPne",0
opcWHILE                byte    "While",0

opc_LIST_END            byte    0


DAT
DAT

opr_LIST_START

opcABS                  byte    "Abs",0
opcLOGAND               byte    "And",0
opcAS                   byte    "As",0
opcBIN                  byte    "Bin",0
opcBYTE                 byte    "Byte",0
opcCHIPVER              byte    "ChipVer",0
opcCHR                  byte    "Chr",0
opcCLKFREQ              byte    "ClkFreq",0
opcCOLOUR               byte    "Colour",0
opcCOLUMN               byte    "Column",0
opcDEC                  byte    "Dec",0
opcEEPROM               byte    "Eeprom",0
opcELSE                 byte    "Else",0
'opcELSEIF               byte    "ElseIf",0
'opcENDDEF               byte    "EndDef",0
'opcENDFUNC              byte    "EndFunction",0
opcENDIF                byte    "EndIf",0
'opcENDSELECT            byte    "EndSelect",0
'opcENDSUB               byte    "EndSub",0
'opcEOF                  byte    "Eof",0
opcFALSE                byte    "False",0
opcHELP                 byte    "Help",0
opcHEX                  byte    "Hex",0
opcHIGHEST              byte    "Highest",0
'opcIN                   byte    "In",0
opcINKEY                byte    "InKey",0
opcIS                   byte    "Is",0
'opcLOF                  byte    "Lof",0
opcLONG                 byte    "Long",0
opcLOWEST               byte    "Lowest",0
opcLSB                  byte    "Lsb",0
opcLSW                  byte    "Lsw",0
opcMAX                  byte    "Max",0
opcMIN                  byte    "Min",0
opcMOD                  byte    "Mod",0
opcMSB                  byte    "Msb",0
opcMSW                  byte    "Msw",0
opcLOGNAND              byte    "Nand",0
opcLOGNOR               byte    "Nor",0
opcLOGNOT               byte    "Not",0
opcNTSC                 byte    "NTSC",0
opcLOGNXOR              byte    "Nxor",0
opcLOGOR                byte    "Or",0
opcNEXT                 byte    "Next",0
opcOFF                  byte    "Off",0
'opcOTHER                byte    "Other",0
opcOUTPUT               byte    "Output",0
opcPAL                  byte    "PAL",0
'opcRESULT               byte    "Result",0
opcRND                  byte    "RND",0
opcROW                  byte    "Row",0
opcSPR                  byte    "SPR",0
opcSQR                  byte    "Sqr",0
opcSTR                  byte    "Str",0
opcTHEN                 byte    "Then",0
opcTAB                  byte    "Tab",0
'opcTO                   byte    "To",0
opcTRUE                 byte    "True",0
opcUNTIL                byte    "Until",0
opxVAR                  byte    "Var",0
opcWEND                 byte    "Wend",0
opcWORD                 byte    "Word",0
opcLOGXNOR              byte    "Xnor",0
opcLOGXOR               byte    "Xor",0

opr_LIST_END            byte    0

DAT
DAT

sym_LIST_START

symABS                  byte    "||",0
symADD                  byte    "+",0
symAND                  byte    "&",0
symANDNOT               byte    "&/",0
symASR                  byte    "~>",0
symAT                   byte    "@",0
symBIT                  byte    "|<",0
symCOLON                byte    ":",0
symCOLONEQ              byte    ":=",0
symCOMMA                byte    ",",0
symDEC                  byte    "--",0
symDIV                  byte    "/",0
symDOT                  byte    ".",0
symDOTDOT               byte    "..",0
symEG                   byte    "=>",0
symEL                   byte    "=<",0
symEQ                   byte    "=",0
symEQEQ                 byte    "==",0
symGE                   byte    ">=",0
symGT                   byte    ">",0
symHASH                 byte    "#",0
symINC                  byte    "++",0
symLBRACE               byte    "{",0,"{",0
symLBRACKET             byte    "[",0
symLE                   byte    "<=",0
symLPARA                byte    "(",0
symLT                   byte    "<",0
symMAX                  byte    "<#",0
symMIN                  byte    "#>",0
symMOD                  byte    "//",0
symMPY                  byte    "*",0
symNAND                 byte    "/&",0
symNE                   byte    "<>",0
symNOR                  byte    "/|",0
symNOT                  byte    "!",0
symNOTEQ                byte    "!=",0
symOR                   byte    "|",0
symORNOT                byte    "|/",0
symPCT                  byte    "%",0
symRND                  byte    "?",0
symRBRACE               byte    "}",0
symRBRACKET             byte    "]",0
symREV                  byte    "><",0
symROL                  byte    "<-",0
symROR                  byte    "->",0
symRPARA                byte    ")",0
symSEMICOLON            byte    ";",0
symSHL                  byte    "<<",0
symSHR                  byte    ">>",0
symSQR                  byte    "^^",0
symSUB                  byte    "-",0
symSXB                  byte    "~",0
symSXW                  byte    "~~",0
symXNOR                 byte    "/^",0
symXOR                  byte    "^",0
symXORNOT               byte    "^/",0

sym_LIST_END            byte      0

DAT
DAT

tag_LIST_START
                                
tagBIN                  byte    "{BIN}",0
tagBYTE                 byte    "{BYT}",0
tagEOF                  byte    "{EOF}",0
tagEOL                  byte    "{EOL}",$0D,0,"End of line",0   
tagHEX                  byte    "{HEX}",0
tagNEW                  byte    "{NEW}",0
tagLONG
tagNUMBER               byte    "{NUM}",0,"Number",0
tagREG                  byte    "{REG}",0,"Register",0
tagREM                  byte    "{REM}",0
tagTRIP                 byte    "{TRP}",0
tagTXT                  byte    "{TXT}",0,"String",0
tagQUD                  byte    "{QUD}",0
tagVAR                  byte    "{VAR}",0,"Variable",0
tagWORD                 byte    "{WRD}",0

tag_LIST_END  

DAT
DAT

reg_LIST_START          byte    "PAR",0         ' $1F0
                        byte    "CNT",0         ' $1F1
                        byte    "INA",0         ' $1F2
                        byte    "INB",0         ' $1F3
                        byte    "OUTA",0        ' $1F4
                        byte    "OUTB",0        ' $1F5
                        byte    "DIRA",0        ' $1F6
                        byte    "DIRB",0        ' $1F7
                        byte    "CTRA",0        ' $1F8
                        byte    "CTRB",0        ' $1F9
                        byte    "FRQA",0        ' $1FA
                        byte    "FRQB",0        ' $1FB
                        byte    "PHSA",0        ' $1FC
                        byte    "PHSB",0        ' $1FD
                        byte    "VCFG",0        ' $1FE
                        byte    "VSCL",0        ' $1FF

reg_LIST_END            byte    0

DAT
DAT

aboFINISHED             byte    "Finished",0
aboSYNTAX_ERROR         byte    "Syntax Error",0
aboUNIMPLEMENTED        byte    "Unimplemented",0
aboNESTING_ERROR        byte    "Nesting Error",0
aboNESTING_TOO_DEEP     byte    "Nesting Too Deep",0
aboFACTOR_EXPECTED      byte    "*Variable or Constant",0
aboCONSTANT_EXPECTED    byte    "*Constant",0
aboSTATEMENT_EXPECTED   byte    "*Statement",0
aboBAD_DIM_SIZE         byte    "Bad Dim Size",0
aboINVALID_VALUE        byte    "Invalid Value",0
aboINVALID_LINENUMBER   byte    "Invalid Line Number",0
aboALREADY_DEFINED      byte    "Already Defined",0
aboINVALID_ARRAY_INDEX  byte    "Invalid Array Index",0
aboNEEDS_ARRAY_INDEX    byte    "*Array Index",0
aboMODIFIER_ERROR       byte    "Type Modifier Error",0
aboFELL_OFF_END         byte    "Reached End of Code",0
aboFILE_OPEN            byte    "File Open",0
aboPIN_IN_USE           byte    "Pin In Use",0
aboINPUT_IN_USE         byte    "Input In use",0
aboBAD_FILE_MODE        byte    "Bad File Mode",0
aboNO_CODE              byte    "No Code",0

aboNO_REALS             byte    "No Reals",0
aboINVALID_DOT          byte    "Invalid Dot",0
aboINVALID_SYMBOL       byte    "Invalid Symbol",0
aboINVALID_NUMBER       byte    "Invalid Number",0
aboUNTERMINATED_STRING  byte    "Unterminated String",0

DAT
DAT

{

                              888                 8888888888 d8b          
                              888                 888        Y8P          
                              888                 888                     
                              888      .d88b.     8888888    888 88888b.  
                              888     d8P  Y8b    888        888 888 "88b 
                              888     88888888    888        888 888  888 
                              888     Y8b.        888        888 888  888 
                              88888888 "Y8888     888        888 888  888

}
DAT
{

ASCII banners from ...

http://www.network-science.de/ascii/

Font: colossal
Reflection: no
Adjustment: center
Stretch: no
Width: 105

Font: serifcap
Reflection: no
Adjustment: left
Stretch: no
Width: 105

}